/**
 * Copyright 2011, FMR LLC. All Rights Reserved. Fidelity Confidential
 * Information
 *
 * @author Eoin O'Connor (a413117)
 * @author Nylon Gao (a488606)
 */

var SIGNUP_ACCOUNT_MSG = "Signup for an account at:<br /><span>Fidelity.com</span>";
var SCHEDULE_CONFIRMATION_HEADER_MSG = "The following bills are now scheduled for payment:";

var PENDING_CONFIRMATION_HEADER_MSG = "You have just changed the &nbsp;&nbsp;following payments:";
var WARN_CONFIRMATION_MSG= "One or more payments we not successfully schedule.......";

var ACCOUNT_LOADING_MSG = "LOADING ACCOUNTS...";
var MAX_CURRENCY = 99999.99;
var DASH_MARK = "--";

var Messages = 
{
    SHOW_BROKERAGE_ACCOUNT_LIST: 'SHOW_BROKERAGE_ACCOUNT_LIST',
    UPDATE_TOTAL_PAYMENT: 'UPDATE_TOTAL_PAYMENT',
    UPDATE_DELIVERY_DATE: 'UPDATE_DELIVERY_DATE',
    GET_DEFAULT_BROKERAGE_ACCOUNT: 'GET_DEFAULT_BROKERAGE_ACCOUNT',
    HIDE_TOOLBAR: 'HIDE_TOOLBAR',
    SHOW_ALERT: 'SHOW_ALERT',
    SWITCH_PAGES: 'SWITCH_PAGES',
    SET_TITLE: 'SET_TITLE',
    EXIT_BILLPAY: 'EXIT_BILLPAY',
    SUBMIT_PAYMENTS: 'SUBMIT_PAYMENTS',
    SUBMIT_CHANGES: 'SUBMIT_CHANGES',
    GET_PAYEE_LIST: 'GET_PAYEE_LIST',
    GET_PENDING_PAYMENTS_LIST: 'GET_PENDING_PAYMENTS_LIST',
    SESSION_TIMEOUT: 'SESSION_TIMEOUT',
    JS_RESULT:'JS_RESULT',
    HIDE_LOADING:'HIDE_LOADING',
    SHOW_LOADING:'SHOW_LOADING',
    DISMISS_MASK:'DISMISS_MASK',
    DISMISS_MASK_SUBMITTING:'DISMISS_MASK_SUBMITTING',
    SHOW_MASK_SUBMITTING:'SHOW_MASK_SUBMITTING',
    POPUP_NUMBER_KEYBOARD:'POPUP_NUMBER_KEYBOARD'
};

var MONTH_CONVERTOR =
{
	'01' : 'Jan',
	'02' : 'Feb',
	'03' : 'Mar',
	'04' : 'Apr',
	'05' : 'May',
	'06' : 'Jun',
	'07' : 'Jul',
	'08' : 'Aug',
	'09' : 'Sep',
	'10' : 'Oct',
	'11' : 'Nov',
	'12' : 'Dec'
};
var MONTH_CONVERTOR_DISORDER =
{
	'Jan' : '01',
	'Feb' : '02',
	'Mar' : '03',
	'Apr' : '04',
	'May' : '05',
	'Jun' : '06',
	'Jul' : '07',
	'Aug' : '08',
	'Sep' : '09',
	'Oct' : '10',
	'Nov' : '11',
	'Dec' : '12'
};
var WEEK_DAY =
{
	0 : 'Sunday',
	1 : 'Monday',
	2 : 'Tuesday',
	3 : 'Wednesday',
	4 : 'Thursday',
	5 : 'Friday',
	6 : 'Saturday'
};
// the amount equal blank.
var AMOUNT_EQUAL_BLANK_MSG = "Please enter an amount for the bill you want to pay.  Click Update Payment when you are finished.";
// the amount is a non-numeric value.
var AMOUNT_IS_A_NON_NUMERIC_MSG = "We don't recognize the amount you typed. The amount should include dollars and cents, for example: 100.00.";
// the amount equal zero or a negative value.
var AMOUNT_EQUAL_ZERO_OR_NEGATIVE_MSG = "You typed a zero or negative amount for the payment. Please type an amount that is greater than or equal to 0.01.";
// the amount is more than $99,999.99.
var AMOUNT_IS_EXCEEDING_MSG = "You typed an amount for the payment that exceeds the maximum payment amount allowed through Fidelity BillPay.  Please type an amount that is less than or equal to $99,999.99.";
// the amount decimal places more than 2.
var AMOUNT_DECIMAL_PLACES_EXCEEDS_TWO_MSG = "You typed an amount for the payment which decimal precision exceeds 2 decimal places.";

var SELECT_A_NEW_DELIVERY_DATE_MSG = "Updating this scheduled payment will require you to select a new delivery date.";
// hide schedule payment warn info
var HIDE_SCHEDULE_WARN_MSG = "You've set up an automatic payment for this bill."
		+ " Changes to the payment selected will not change any other scheduling options for this bill."
		+ " If you would like to change your automatic payment scheduling options, please go to Fidelity.com.";
// hide pending payment warn info
var HIDE_PENDING_WARN_MSG = "You've set up an automatic payment for this bill."
		+ " Changes to the payment selected will not change any other scheduling options for this bill."
		+ " If you would like to change your automatic payment scheduling options, please go to Fidelity.com.";
var TIME_OUT_PARAMETER = "\/ftgw\/Fas\/Fidelity\/RtlCust\/Login\/Response";
var TIME_OUT_LOGIN_PARAMETER = "Login to Fidelity.com, Charitable Gift Fund and NetBenefits Sites";