/**
 * Copyright 2011, FMR LLC. All Rights Reserved. Fidelity Confidential
 * Information
 * 
 * @author Ice Wang (a492978)
 * @author Eoin O'Connor (a413117)
 * @author Nylon Gao (a488606)
 */
/* Local Variables */

// selected payee item in the payee list of schedule payment.
var selected_schedule_id = '';
// selected payee item in the payee list of pending payment.
var selected_pending_id = '';
// the status Of updated scheudle or pending .
var is_back_to_schedule_tab = false;
var is_back_to_pending_tab = false;
// record your operated status when you click cancle or update button in the
// schedule payment page or in the update payment page.
var is_cancle_pending = false;
var is_update_pending = false;
var is_cancle_schedule = false;
var is_update_schedule = false;
// record the amount when you update or add a delivery accounts.
var amount_on_update_button;
// record the delivery date,when you update or add a delivery date.
var payment_deliver_date;
// page transition stack
var page_transition_stack = [];
// verify double click or not.isDoubleClick
var is_item_line_double_click = true;
// verify schedule or pending confirmation(value equals 'schedule' or
// 'pending').
var confirmation = "";
// get the confirmation json data which is responsed from webservice.
var confirmation_json = "";
var is_closed = false;
var is_closed_modal = false;
var hoverdelay = null;
// verify status of submit pending or schedule is true or false.
var is_submit_pending = true;
var is_submit_schedule = true;
// verify status of loading pending or schedule is true or false.
var is_loading_pending = false;
var is_loading_schedule = true;
// verify submitted data is error or not
var is_error_pending_submit = false;
var is_error_schedule_submit = false;
// successful submited data array.
var success_data_array = [];
var rotate_delay ;
//avoid double click prev
var is_double_click = false;
//network error toolbar text
var network_error_toolbar_text = "";
//click view_pending_payments or pay_more_bills button,record the status.
var is_execute_view_pending_payments = true;
var is_execute_pay_more_bills = true;
//init loading validation
var init_update_schedule_loading = true;
var init_update_pending_loading = true;
var init_billpay_error_loading = true;
var init_confirmation_loading = true;
var init_dismiss_mark_loading = true;
var click_from_tab = false;
//when confirmation info page display a warn msg.then is_click_billpay_error_page = true.
var is_click_billpay_error_page = false;
//if page goes back from autopay detail page.the variable would be true.
var is_back_from_auto_pay = false;

var is_click_brokerage_account = true;
var is_execute_spinner = true; 

// Initialize the jqTouch library
var JQT = $.jQTouch(
		{
		    touchSelector: 'a, .touch, li , label, div,h4',
		    fixedViewport: false,
		    useFastTouch: false,
		    isIpad: false,
		    useAnimations:false
		});


/**
 * Wrapper around base JS implementation of alert. Native wrapper will intercept
 * and display message.
 */
function showAlertBox(argType, argAlertTitle, argMessage, argLeftButtonTitle, argRightButtonTitle, argCallback)
{
    var paramObj = 
    {
	 	"Type": argType,
	 	"AlertTitle":argAlertTitle,
	 	"Message":argMessage,
	 	"LeftButtonTitle":argLeftButtonTitle,	
	 	"RightButtonTitle":null,
	 	"Callback":null
    };
    if (argRightButtonTitle !== undefined && argCallback !== undefined)
    {
    	paramObj.callback = argCallback;
    	paramObj.rightButtonTitle = argRightButtonTitle;
    }
    sendRequestToContainer(Messages.SHOW_ALERT, paramObj);
}

//when the schedule or pending data has been loaded.the spinners would be hidden.
function hideLoadingSpinners()
{
	sendRequestToContainer(Messages.HIDE_LOADING,null);
}
//when loading the schedule or pending data.the spinners would be shown.
function showLoadingSpinners()
{
	sendRequestToContainer(Messages.SHOW_LOADING,null);
}

/**
 * Function to display error page.
 * @param argMessageType
 * @param argMessageTitle
 * @param argIsEligibilityError
 */
function goToErrorPage(argMessageType, argMessageTitle, argIsEligibilityError)
{
	hideLoadingSpinners();
    JQT.goTo('#eligibility_error', 'fade');
    if (argMessageType == 'fiserv_connection' || argMessageType == 'oltx_ws_connection') 
    {
        $('#eligibility_error_content').append($('#fiserv_connection').text());
    }
    else if (argMessageType.toLowerCase() == 'unavailable_error') 
    {
        $('#eligibility_error_content').append($('#unavailable_error').text());
    }
    else if (argMessageType != null && $.trim(argMessageType).length != 0) 
    {
        $('#eligibility_error_content').append(argMessageType);
    }
    if (argIsEligibilityError === undefined || !argIsEligibilityError) 
    {
        $("#signup_account").empty();
    }
    else 
    {
    	 $("#signup_account").append(SIGNUP_ACCOUNT_MSG);
    }
    sendRequestToContainer(Messages.DISMISS_MASK,null);
    sendRequestToContainer(Messages.DISMISS_MASK_SUBMITTING,null);
    switchPages("", "", "", argMessageTitle, "NO");
}

/**
 *  set brokerage argAccount.
 * @param argAccount
 */
function setBrokerageAccount(argAccount,argIsLoadingSpinners)
{
    if ($("#tab_bar_pending").hasClass("select"))
    {
    	$("#pending_see_history_info").show();
    }else	
    {
    	$("#pending_see_history_info").hide();
    }
    
    $("#hide_selected_account").val($("#hide_whole_selected_account").val());
    $("#txt_accounts_list").val(formatAccount(argAccount));
    
    $("#hide_whole_selected_account").val(argAccount);
    var paramObj = {"SelectedAccount":getAccountNumber(argAccount)};
    
    if (is_click_brokerage_account && !isEarliestDateCached() && $("#tab_bar_pending").hasClass("select") )
    {
    	sendRequestToContainer(Messages.GET_PENDING_PAYMENTS_LIST, paramObj);
    }
    else
    {
    	sendRequestToContainer(Messages.GET_PAYEE_LIST, paramObj);
    }
    if ($("#tab_bar_pending").hasClass("select") && is_click_brokerage_account)
    {
    	switchPages("PREVIEW_PENDING_PAYMENT", "DISABLE", '0.00', "Pay Bills", "YES", 'NO');
    }else
    {
    	switchPages("PREVIEW_SCHEDULING_PAYMENT", "DISABLE", '0.00', "Pay Bills", "YES", 'NO');
    }
    removeAccountBoxShadow();
    if(init_dismiss_mark_loading)
    {
    	init_dismiss_mark_loading = false;
    	sendRequestToContainer(Messages.DISMISS_MASK,null);
    }
    //show loading spinners.so that loading data
    if(argIsLoadingSpinners != false)
    {
    	showLoadingSpinners();
    } 
}

/**
 *  set brokerage argAccount.
 * @param argAccount
 */
function setBrokerageAccountForAutoLoadAccount(argAccount,argIsLoadingSpinners)
{
    if ($("#tab_bar_pending").hasClass("select"))
    {
    	$("#pending_see_history_info").show();
    }else
    {
    	$("#pending_see_history_info").hide();
    }
    
    $("#hide_selected_account").val($("#hide_whole_selected_account").val());
    $("#txt_accounts_list").val(formatAccount(argAccount));
    
    $("#hide_whole_selected_account").val(argAccount);
    removeAccountBoxShadow();
    if(init_dismiss_mark_loading)
    {
    	init_dismiss_mark_loading = false;
    	sendRequestToContainer(Messages.DISMISS_MASK,null);
    }
    //show loading spinners.so that loading data
    if(argIsLoadingSpinners != false)
    {
    	showLoadingSpinners();
    } 
}

/**
 * format account value and avoid the account length exceeding limit.
 * @param argAccount
 */
function formatAccount(argAccount)
{
    var account_name = argAccount.substring(0, argAccount.lastIndexOf('(') - 1);
    var account_number = getAccountNumber(argAccount);
    if (account_name.length > 24) 
    {
        account_name = account_name.substring(0, 22) + "...";
    }
    return account_name + " (" + account_number + ")";
}

/**
 * submit data from schedule payments updated to object-c.
 */
function confirmSubmitPayments()
{
	sendRequestToContainer(Messages.SHOW_MASK_SUBMITTING,null);
    confirmSubmitPaymentsOK();
}

/**
 * submit payee items changed of schedule payment.
 */
function confirmSubmitPaymentsOK()
{
    is_error_schedule_submit = true;
    postDataOfSubmitPayments(getSubmitPaymentsString());
}

 /**
  * submit data from pending payments updated to object-c.
  */
function confirmSubmitChanges()
{
	sendRequestToContainer(Messages.SHOW_MASK_SUBMITTING,null);
    confirmSubmitChangesOK();
}

/**
 * submit payee items changed of pending payment.
 */
function confirmSubmitChangesOK()
{
    is_error_pending_submit = true;
    postDataOfSubmitChanges(getSubmitChangesString());
}

/**
 * get data from schedule payments updated.
 */
function getSubmitPaymentsString()
{
    var submit_payments_string = "",
        number = 1,
        account;
    var submit_length = $("#preview_payment_content>article").length;
    for (number; number <= submit_length; number++)
    {
        var payee = $('#payment_payee' + number).text();
        var amount = unFormatMoney($('#payment_amount' + number).text().substring(1));
        var deliverby = getSubmitFormatDate($('#payment_deliverby' + number).text());
        var payeeid = $('#payment_payee_id' + number).text();
        var ebillid = $('#payment_ebill_id' + number).text();
        submit_payments_string += "OPERATION_" + number + "=ADD&PAYEE_ID_" + number + "=" + payeeid + "&EBILL_ID_" + number + "=" + ebillid + "&AMOUNT_" + number + "=" + amount + "&PAYMENT_DATE_" + number + "=" + deliverby + "&";
    }
    var whole_account_number = $('#payment_account1').text();
    account = getAccountNumber(whole_account_number);
    submit_payments_string = "ACCOUNT=" + account + "&" + submit_payments_string + "NUM_OF_PAYMENTS=" + (number - 1);
    return submit_payments_string;
}

/**
 * get data from pending payments updated.
 */
function getSubmitChangesString()
{
    var submit_changes_string = "",
        number = 1,
        account;
    var submit_length = $("#preview_changes>article").length;
    for (number; number <= submit_length; number++)
    {
        var payee = $('#changes_payee' + number).text();
        var amount = $('#changes_amount' + number).text();
        var deliverby = getSubmitFormatDate($('#changes_deliverby' + number).text());
        var transaction_id = $('#preview_pending_transaction_id' + number).text();
        if (amount != "CANCELLED")
        {
            amount = unFormatMoney(amount.substring(1));
            submit_changes_string += "OPERATION_" + number + "=UPDATE&TXN_ID_" + number + "=" + transaction_id + "&AMOUNT_" + number + "=" + amount + "&PAYMENT_DATE_" + number + "=" + deliverby + "&";
        }
        else
        {
            submit_changes_string += "OPERATION_" + number + "=CANCEL&TXN_ID_" + number + "=" + transaction_id + "&";
        }
    }
    var whole_account_number = $('#changes_account1').text();
    account = getAccountNumber(whole_account_number);
    submit_changes_string = "ACCOUNT=" + account + "&" + submit_changes_string + "NUM_OF_PAYMENTS=" + (number - 1);
    return submit_changes_string;
}

/**
 * bill page submit.
 */
function pendingClickHandler()
{
    $("#tab_bar_pending").addClass("select");
    $("#tab_bar_schedule").removeClass("select");
    $("#div_schedule").hide();
    $("#div_pending").show();
}

/**
 * change tab.
 */
function scheduleClickHandler()
{
    $("#tab_bar_pending").removeClass("select");
    $("#tab_bar_schedule").addClass("select");
    $("#div_pending").hide();
    $("#div_schedule").show();
}


/**
 * send deliver date of schedule payment.
 * @param argCurrentDate
 * @param argDueDate
 * @param argIsWarnInfo
 * @param argIsEarliestDate
 */
function sendDeliverDateOfSchedulePayment(argCurrentDate, argDueDate, argIsWarnInfo, argIsEarliestDate)
{
	
    var paramObj = 
    {
	 	"DueDate": argDueDate,
	 	"CurrentDate":argCurrentDate,
	 	"IsWarnInfo":argIsWarnInfo,
	 	"EarliestDate":argIsEarliestDate
    };
    sendRequestToContainer(Messages.UPDATE_DELIVERY_DATE,paramObj);
}

/**
 * set deliver date of page.
 * @param argDateString
 */
function setDeliverDateOfSchedulePayment(argDateString)
{
    var weekday = getWeekDay(argDateString);
    $('#txt_schedule_deliver_date').val(' ' + weekday + "," + ' ' + argDateString);
    $('#txt_pending_deliver_date').val(' ' + weekday + "," + ' ' + argDateString);
    setUpdateButtonDisableEvent();
    removeDateBoxShadow();
}

/**
 * verify the update button disable or enable.
 */
function setUpdateButtonDisableEvent()
{
    var temp_id_string;
    if ($.trim(selected_pending_id).length != 0) 
    {
        temp_id_string = '#update_pending_payment';
        if (!isUpdateButtonDisabled("pending")) 
        {
            $(temp_id_string).attr("disabled", "").removeClass("btn-disabled");
        }
        else 
        {
            $(temp_id_string).attr("disabled", "disabled").addClass("btn-disabled");
        }
    }
    else if ($.trim(selected_schedule_id).length != 0) 
    {
        temp_id_string = '#update_schedule_payment,#schedule_schedule_payment';
        if (!isUpdateButtonDisabled("schedule")) 
        {
            $(temp_id_string).attr("disabled", "").removeClass("btn-disabled");
        }
        else 
        {
            $(temp_id_string).attr("disabled", "disabled").addClass("btn-disabled");
        }
    }
}

/**
 * preview total pay page
 */
function previewPayment()
{
    if (!is_double_click)
    {
        is_double_click = true;
        success_data_array = [];
        goBackInfomations("PREVIEW_SCHEDULING_PAYMENT", "ENABLE", $("#schedule_total_pay").val(), "Pay Bills", "YES", null);
        JQT.goTo('#preview_payment', 'slide'); // animation
    }
}

/**
 * preview changes page.
 */
function previewChanges()
{
    if (!is_double_click)
    {
        is_double_click = true;
        success_data_array = [];
        goBackInfomations("PREVIEW_PENDING_PAYMENT", "ENABLE", $("#pending_total_pay").val(), "Pay Bills", "YES", null);
        JQT.goTo('#preview_changes', 'slide'); // animation
    }
}

/**
 * go to retained page when appearing network error
 * @return
 */
function gotoNetworkErrorPage()
{
     var current_page_info = page_transition_stack[page_transition_stack.length - 1];
     $.modal.close();
     $("#load_submit_info").hide();
     switchPages(current_page_info[0], "", "", current_page_info[3], "YES");
     page_transition_stack.pop(page_transition_stack.length - 1);
}

/**
 * count total pay of pending payment.
 */
function countTotalPayOfPendingPayment()
{
    var total_pending_payment_amount = 0;
    $(".pending-price").each(function()
    {
        total_pending_payment_amount += unFormatMoney($(this).text());
    });
    $('#pending_total_pay').val(formatNumber(formatMoney(total_pending_payment_amount)));
}

/**
 * count total pay of schedule payment.
 */
function countTotalPayOfSchedulePayment()
{
    var total_schedule_payment_amount = 0;
    $(".added").each(function()
    {
        total_schedule_payment_amount += unFormatMoney($(this).text().substring(1));
    });
    $('#schedule_total_pay').val(formatNumber(formatMoney(total_schedule_payment_amount)));
}

/**
 * Get the list of eligibile BillPay accounts
 */
function getBillpayAccounts()
{
    var obj = parseJsonMsg($('#account_msg_string').val());
    var account_array_obj = obj.BillPay.accountEligibilityDetails.detail;
    var selected_account_obj = getSelectedAccount();
    var account_arr= [];
    
    var accountObj = 
    {
    	"SelectedAccountName":null,
    	"SelectedAccountNo":null,
    	"AccountArray":null

    };
    

    for (var i = 0; i < account_array_obj.length; i++)
    {
        var singleAccount = {
        		"SequenceId":0,
                "AccountName":null,
                "AccountNo": null		
        };
        if (account_array_obj[i].billPayStatus == "AC")
        {
            var account_name = account_array_obj[i].accountName;
            if (selected_account_obj.accountNumber == account_array_obj[i].accountNumber)
            {
            	accountObj.SelectedAccountName = account_name;
            	accountObj.SelectedAccountNo = selected_account_obj.accountNumber;
            }
            singleAccount.SequenceId = i+1;
            singleAccount.AccountName = account_name;
            singleAccount.AccountNo = account_array_obj[i].accountNumber;
        }
        account_arr.push(singleAccount);
    }
    accountObj.AccountArray = account_arr;
    return accountObj;
}

/**
 * get selected account.
 */
function getSelectedAccount()
{
    var obj = parseJsonMsg($('#account_msg_string').val());
    var account_array_obj = obj.BillPay.accountEligibilityDetails.detail;
    var whole_account_number = $('#hide_whole_selected_account').val();
    var selected_account;
    if ($('#txt_accounts_list').val() != '') 
    {
        selected_account = getAccountNumber(whole_account_number);
    }
    else 
    {
        selected_account = obj.BillPay.selectedAccount;
    }
    for (var i = 0; i < account_array_obj.length; i++) 
    {
        if (selected_account == account_array_obj[i].accountNumber) 
        {
            return account_array_obj[i];
        }
    }
    if (account_array_obj.length > 0) 
    {
        return account_array_obj[0];
    }
    return "";
}

/**
 * set pending payment item list.
 * @param argMsg
 */
function setPendingPayment(argMsg)
{
    var obj = parseJsonMsg(argMsg);
    
    // 'payment array obj' in obj
    var pending_payment_array_obj;
    
    $('#div_pending>ul').removeClass('empty-payee-payment').empty();
    // if payment account has pending payment
	if (obj.BillPay !== undefined && obj.BillPay.paymentList !== undefined && obj.BillPay.paymentList.payment !== undefined && obj.BillPay.paymentList.payment.length != 0)
    {
        pending_payment_array_obj = obj.BillPay.paymentList.payment;
        parseJsonObjToPendingPayments(pending_payment_array_obj);
    }
    else 
    {
        $('#div_pending>ul').addClass('empty-payee-payment').append(obj.BillPay.resultInfo.userMessage);
    }
    
    var available_balance = '0.00';
    if (obj.BillPay !== undefined) 
    {
        if (obj.BillPay.cashAvailableToWithdraw === undefined || obj.BillPay.cashAvailableToWithdraw == '--') 
        {
            available_balance = '--';
            showAlertBox("YES", "Balance Error", "Balance information unavailable.", "OK");
        }
        else 
        {
            available_balance = '$' + formatNumber(obj.BillPay.cashAvailableToWithdraw);
        }
        // display cashAvailableToWithdraw on Available Balance
        $('#cash_available_to_withdraw').text(available_balance);
        $('#hide_cash_available_to_withdraw').val(available_balance);
    }
    
    if ($('#cash_available_to_withdraw').text() != "" && $('#tab_bar_pending').hasClass('select')) 
    {
    	hideLoadingSpinners();
    }
    $("#hide_selected_account").val($('#hide_whole_selected_account').val());
    if ($("#tab_bar_pending").hasClass("select")) 
    {
        $("#pending_see_history_info").show();
    }else
    {
    	$("#pending_see_history_info").hide();
    }
    if ($("#tab_bar_pending").hasClass("select"))
    {
	    countTotalPayOfPendingPayment();
	    var result = $("#pending_total_pay").val(); 
	    var paramObj = {"Type":"SET_PENDING_PAYMENT","Result":result};
	    sendRequestToContainer(Messages.JS_RESULT,paramObj);
    }
}

/**
 * transfer json data.
 * @param argPendingPaymentArrayObj
 */
function parseJsonObjToPendingPayments(argPendingPaymentArrayObj)
{
    var pending_payment_string = "";
    var pending_payment_obj;
    var index = 0;
    for (var i = 0; i < argPendingPaymentArrayObj.length; i++)
    {
        var recurring_flag = "",
            recurring_label = "";
        var payee_name = "";
        var nick_name = "";
        var maske_account_number = "";
        var auto_pay = "";
        var processing = "";

        pending_payment_obj = argPendingPaymentArrayObj[i];
        index++;

        if (pending_payment_obj.recurring == "true")
        {
            recurring_flag = "Recurring";
        }
        if ($.trim(pending_payment_obj.warnInfo).length != 0)
        {
            recurring_label = "<label id=\"item_pending_recurring" + index + "\">" + pending_payment_obj.warnInfo + "</label>";
        }
        if (pending_payment_obj.payee !== undefined && pending_payment_obj.payee.payeeName !== undefined)
        {
            payee_name = pending_payment_obj.payee.payeeName;
        }
        if (pending_payment_obj.payee !== undefined && pending_payment_obj.payee.payeeNickName !== undefined && $.trim(pending_payment_obj.payee.payeeNickName) != 0)
        {
            payee_name = "";
            nick_name = pending_payment_obj.payee.payeeNickName;
        }
        if (pending_payment_obj.payee.accountNumber !== undefined && $.trim(pending_payment_obj.payee.accountNumber).length != 0)
        {
            maske_account_number = " - <a>" + getMaskedAccountNumber(pending_payment_obj.payee.accountNumber) + "</a>";
        }
        if ($.trim(pending_payment_obj.automaticPaymentEnabled) == "true")
        {
            auto_pay = "<label class=\"auto-pay\" id=\"pending_lbl_auto_pay" + index + "\">AUTO PAY</label><label>&nbsp;</label>";
        }
        if ($.trim(pending_payment_obj.status) == "InProcess")
        {
            processing = " Processing";
        }

        pending_payment_string =
            "<li id=\"pending_"+index+"\" class=\"table-row\"><a>"+
			"<div class=\"list-item\">"+
			"<h4 id=\"item_pending_name"+index+"\" class=\"color333\">"+payee_name+nick_name+
            "<label id=\"item_pending_number"+index+"\" class=\"account-number\">"+maske_account_number+"</label></h4>"+
			"<div id=\"span_deliver_info"+index+"\" class=\"color666\">"+ auto_pay +
			recurring_label +
			"<label id=\"item_pending_type"+index+"\">"+recurring_flag+" Deliver by</label>"+
			"<label id=\"item_pending_date"+index+"\">  "+formatDate(pending_payment_obj.paymentDate)+"</label>"+
			"<label>"+processing+"</label>"+
			"</div>"+
			"</div>"+
			"<div class=\"pending sub\" id=\"div_item_pending_price"+index+"\">"+
			"<label id=\"symbol"+index+"\">$</label>"+
			"<label id=\"item_pending_price"+index+"\" class=\"pending-price\">"+formatNumber(pending_payment_obj.paymentAmount)+"</label>"+
			"</div>"+
			"<div class=\"display-none\">"+
            "<label id=\"item_pending_payee_name"+index+"\">"+payee_name+nick_name+"</label>"+
            "<label id=\"item_pending_payee_earliest_date"+index+"\">"+formatDate(getPendingPaymentEarliestDate(pending_payment_obj.payee.payeeId))+"</label>"+
            "<label id=\"item_pending_account_number"+index+"\">"+pending_payment_obj.payee.accountNumber+"</label>"+
			"<label id=\"item_pending_transaction_id"+index+"\">"+pending_payment_obj.transactionId+"</label>"+
			"<label id=\"item_pending_confirmation_number"+index+"\">"+pending_payment_obj.confirmationNumber+"</label>"+
			"<label id=\"item_pending_new_price"+index+"\">"+formatNumber(pending_payment_obj.paymentAmount)+"</label>"+
			"<label id=\"item_pending_last_price"+index+"\"></label>"+
			"<label id=\"item_pending_new_date"+index+"\">  "+formatDate(pending_payment_obj.paymentDate)+"</label>"+
			"<label id=\"item_pending_status"+index+"\">  "+pending_payment_obj.status+"</label>"+
			"</div>"+
			"</a></li>";
        $('#div_pending>ul').append(pending_payment_string);

        if ($.trim(pending_payment_obj.status) != "InProcess")
        {
            $('#pending_' + index).bind('click', function ()
            {
                if (is_item_line_double_click)
                {
                    pending_id = $(this).attr('id');
                    selected_pending_id = pending_id.substring(pending_id.indexOf("_") + 1);
                    if(click_from_tab && selected_pending_id == '1')
                    {
                    	click_from_tab = false;
                    	return false;
                    }
                    else
                    {
	                    is_item_line_double_click = false;
	                    var is_toolbar_enable = "DISABLE";
	                    if (isPendingPaymentChanged())
	                    {
	                        is_toolbar_enable = "ENABLE";
	                    }
	                    goBackInfomations("PREVIEW_PENDING_PAYMENT", is_toolbar_enable, $("#pending_total_pay").val(), "Pay Bills", "YES", null);
	                    JQT.goTo('#update_pending', 'slide'); // animation.
                    }
                }
            });
        }
    }
}

/**
 * 
 * @param {Object}
 *            argAccountList
 * @param {Object}
 *            argTypeName
 */

function setAccountList(argAccountList, argTypeName)
{
    // set message to account_msg_string for schedule payment available account
    $('#account_msg_string').val(argAccountList);

    var obj = parseJsonMsg(argAccountList);
    var selected_account;
    var selected_payment_obj;
    
    if (typeof obj == "object" && obj.BillPay !== undefined && obj.BillPay.selectedAccount !== undefined)
    {
        if (obj.BillPay.accountEligibilityDetails !== undefined && obj.BillPay.accountEligibilityDetails.detail !== undefined && obj.BillPay.accountEligibilityDetails.detail.length != 0)
        {
            // get payment account selected
            selected_payment_obj = getSelectedAccount();
            if (selected_payment_obj != "" && selected_payment_obj !== undefined && typeof(selected_payment_obj) == 'object' && selected_payment_obj.accountNumber !== undefined)
            {
                var account = $.trim($("#hide_whole_selected_account").val());
                if (account == null || account === undefined || account.length <= 0)
                {
                    account = selected_payment_obj.accountName + ' (' + selected_payment_obj.accountNumber + ')';
                }
                var accountNumber = getAccountNumber(account);
                setBrokerageAccountForAutoLoadAccount(account,false);
                selected_account = accountNumber;
                var paramObj = {"SelectedAccount":accountNumber};
                if (argTypeName.toUpperCase() == "PENDING" && $("#tab_bar_pending").hasClass("select") && !isEarliestDateCached())
                {
                	sendRequestToContainer(Messages.GET_PENDING_PAYMENTS_LIST, paramObj);
                	if(!is_back_to_schedule_tab && !is_back_to_pending_tab && is_execute_spinner){
                		showLoadingSpinners();
                	}
                }
                else 
                {
                	sendRequestToContainer(Messages.GET_PAYEE_LIST, paramObj);
                	if(!is_back_to_schedule_tab && !is_back_to_pending_tab && is_execute_spinner ){
                		showLoadingSpinners();
                	}
                	
                }
                return true;
            }
        }
    }
    goToErrorPage(obj.BillPay.resultInfo.userMessage, 'Eligibility Error', true);
}

/**
 * set schedule payment contents.
 * @param argMsg     json string.
 */
function setSchedulePayment(argMsg)
{
	if ($("#tab_bar_schedule").hasClass("select")) 
	{
	    $("#pending_see_history_info").hide();
	}else
	{
		$("#pending_see_history_info").show();
	}
    // parse schedule payment json string to js obj
    var obj = parseJsonMsg(argMsg);
    // 'payment array obj' in obj
    var schedule_payment_array_obj;
    $('#div_schedule>ul').empty();
    if (obj.BillPay !== undefined && obj.BillPay.paymentList !== undefined && obj.BillPay.paymentList.payment !== undefined && obj.BillPay.paymentList.payment.length != 0)
    {
        // get payment array obj
    	$('#hide_shcedule_payment_string').val(argMsg);
        schedule_payment_array_obj = obj.BillPay.paymentList.payment;
        $('#div_schedule>ul').removeClass('empty-payee-payment');
        parseJsonObjToSchedulePayments(schedule_payment_array_obj);
    }
    else
    {
        $('#div_schedule>ul').addClass('empty-payee-payment');
        $('#div_schedule>ul').append(obj.BillPay.resultInfo.userMessage);
    }

    var available_balance = '0.00';
    if (obj.BillPay !== undefined)
    {
        if (obj.BillPay.cashAvailableToWithdraw === undefined || obj.BillPay.cashAvailableToWithdraw == '--')
        {
            available_balance = DASH_MARK;
            showAlertBox("YES", "Balance Error", "Balance information unavailable.", "OK");
        }
        else
        {
            available_balance = '$' + formatNumber(obj.BillPay.cashAvailableToWithdraw);
        }
    }
    // display cashAvailableToWithdraw on Available Balance
    $('#cash_available_to_withdraw').text(available_balance);
    $('#hide_cash_available_to_withdraw').val(available_balance);
    $("#hide_selected_account").val($('#hide_whole_selected_account').val());
    var result;
    if ($("#tab_bar_pending").hasClass("select"))
    {
        sendRequestToContainer(Messages.GET_PENDING_PAYMENTS_LIST, {"SelectedAccount":obj.BillPay.selectedAccount});
        result = "0.00";
    }
    else
    {
	    if ($('#cash_available_to_withdraw').text() != "")
	    {
	    	hideLoadingSpinners();
	    }
	    countTotalPayOfSchedulePayment();
	    result = $("#schedule_total_pay").val();
    }
    var paramObj = {"Type":"SET_SCHEDULE_PAYMENT","Result":result};
    sendRequestToContainer(Messages.JS_RESULT,paramObj);
}
/**
 * transfer the json data.
 * @param argSchedulePaymentArrayObj
 */
function parseJsonObjToSchedulePayments(argSchedulePaymentArrayObj)
{
    var index = 0;
    var schedule_payment_obj;
    var schedule_payment_string = "",
        share_payment_string = "";

    for (var i = 0; i < argSchedulePaymentArrayObj.length; i++)
    {
        var payee_name = "",
            nick_name = "",
            mask_account_number = "",
            auto_pay = "",
            payee_id = "";
        index = i + 1;
        schedule_payment_obj = argSchedulePaymentArrayObj[i];
        var bills_list_value = schedule_payment_obj.payee;
        var earliest_payment_date = formatDate(bills_list_value.earliestPaymentDate);
        var next_payment_date = formatDate(bills_list_value.nextPaymentDate);
        var last_payment_amount, last_payment_date;
        if (schedule_payment_obj.paymentAmount !== undefined)
        {
            last_payment_amount = formatNumber(schedule_payment_obj.paymentAmount);
        }
        else
        {
            last_payment_amount = "";
        }
        if (schedule_payment_obj.paymentDate !== undefined)
        {
            last_payment_date = formatDate(schedule_payment_obj.paymentDate);
        }
        else
        {
            last_payment_date = "";
        }

        if (bills_list_value !== undefined && bills_list_value.payeeName !== undefined && $.trim(bills_list_value.payeeName).length != 0)
        {
            payee_name = bills_list_value.payeeName;
        }
        if (bills_list_value !== undefined && bills_list_value.payeeId !== undefined && $.trim(bills_list_value.payeeId).length != 0)
        {
            payee_id = bills_list_value.payeeId;
        }
        if (bills_list_value !== undefined && bills_list_value.payeeNickName !== undefined && $.trim(bills_list_value.payeeNickName).length != 0)
        {
            payee_name = "";
            nick_name = bills_list_value.payeeNickName;
        }
        if (bills_list_value !== undefined && bills_list_value.accountNumber !== undefined && $.trim(bills_list_value.accountNumber).length != 0)
        {
            mask_account_number = " - <a>" + getMaskedAccountNumber(bills_list_value.accountNumber) + "</a>";
        }
        if ($.trim(schedule_payment_obj.automaticPaymentEnabled) == "true")
        {
            auto_pay = "<label class=\"auto-pay\" id=\"schedule_lbl_auto_pay" + index + "\">AUTO PAY</label><label>&nbsp;</label>";
        }

        schedule_payment_string = 
            "<li id=\"schedule_"+index+"\" class=\"table-row\"><a>"+
			"<div class=\"list-item\">"+
			"<h4 id=\"item_schedule_name"+index+"\" class=\"color333\">"+payee_name+nick_name+
            "<label id=\"item_schedule_number"+index+"\" class=\"account-number\">"+mask_account_number+"</label></h4>"
			"<div id=\"span_schedule_ebill"+index+"\" class=\"color666\">" + auto_pay;
        
		share_payment_string = 
            "<label id=\"last_payment_label"+index+"\"></label>"+"<label id=\"lbl_symbol"+index+"\"></label><label id=\"item_schedule_price"+index+"\"></label>&nbsp;"+
			"<label id=\"item_label"+index+"\"></label>&nbsp;"+
			"<label id=\"item_schedule_date"+index+"\"></label>"+
			"</div>" +
            "</div>" +
            "<div class=\"schedule sub\" id=\"item_schedule"+index+"\">Schedule</div>" +
            "<div class=\"display-none\">"+
            "<label id=\"item_schedule_payee_name"+index+"\">"+payee_name+nick_name+"</label>"+
            "<label id=\"item_schedule_account_number"+index+"\">"+bills_list_value.accountNumber+"</label>"+
            "<label id=\"item_schedule_payee_id"+index+"\">"+bills_list_value.payeeId+"</label>"+
            "<label id=\"item_earliest_payment_date"+index+"\">"+earliest_payment_date+"</label>"+
            "</div>"+
            "</a></li>";
		if($.trim(schedule_payment_obj.eBillEnabled) == "true")
        {
            if(bills_list_value.ebillsList !== undefined && bills_list_value.ebillsList.eBill !== undefined && bills_list_value.ebillsList.eBill.length > 0 && bills_list_value.ebillsList.eBill[0].billStatus.toUpperCase() != "PAID")
            {
                bills_list_value = bills_list_value.ebillsList.eBill;
				var amount_due = bills_list_value[0].amountDue;
				var due_date = formatDate(bills_list_value[0].dueDate);
				var bill_status = bills_list_value[0].billStatus;
				var ebill_id = bills_list_value[0].ebillId;
				schedule_payment_string += 
					"<label id=\"last_payment_label"+index+"\"></label>"+
					"<label id=\"lbl_symbol\">$</label><label id=\"item_schedule_price"+index+"\">"+formatNumber(amount_due)+"</label>&nbsp;"+
					"<label id=\"item_label"+index+"\">due</label>&nbsp;"+
					"<label id=\"item_schedule_date"+index+"\">"+due_date+"</label>"+
					"</div>"+
					"</div>"+
					"<div class=\"schedule sub\" id=\"item_schedule"+index+"\">Schedule</div>"+
					"<div class=\"display-none\">"+
                    "<label id=\"item_schedule_payee_name"+index+"\">"+payee_name+nick_name+"</label>"+
                    "<label id=\"item_schedule_account_number"+index+"\">"+bills_list_value.accountNumber+"</label>"+
					"<label id=\"item_schedule_payee_id"+index+"\">"+payee_id+"</label>"+
					"<label id=\"item_schedule_ebill_id"+index+"\">"+ebill_id+"</label>"+
                    "<label id=\"item_earliest_payment_date"+index+"\">"+earliest_payment_date+"</label>"+
                    "<label id=\"last_payment_amount"+index+"\">"+last_payment_amount+"</label>"+
					"<label id=\"last_payment_due_date"+index+"\">"+last_payment_date+"</label>"+
                    "<label id=\"ebill_due_date"+index+"\">"+due_date+"</label>"+
					"<label id=\"ebill_amount_due"+index+"\">"+amount_due+"</label>"+
					"<label id=\"last_payment_bill_status"+index+"\">"+bill_status+"</label>"+
					"<label id=\"is_show"+index+"\">"+true+"</label>"+
					"</div>"+
					"</a></li>";
			}
            else
            {
                schedule_payment_string += share_payment_string;
            }
		}
        else
        {
            if(schedule_payment_obj.paymentAmount !== undefined && schedule_payment_obj.paymentDate !== undefined && schedule_payment_obj.status !== undefined )
            {
                var last_payment_bill_status = schedule_payment_obj.status;
                schedule_payment_string += 
					"<label id=\"last_payment_label"+index+"\">Last Payment: </label>"+
                    "<label id=\"lbl_symbol"+index+"\">$</label><label id=\"item_schedule_price"+index+"\">"+last_payment_amount+"</label>&nbsp;"+
                    "<label id=\"item_label"+index+"\">on</label>&nbsp;"+
                    "<label id=\"item_schedule_date"+index+"\">"+last_payment_date+"</label>"+
                    "</div>"+
                    "</div>" +
                    "<div class=\"schedule sub\" id=\"item_schedule"+index+"\">Schedule</div>" +
                    "<div class=\"display-none\">"+
                    "<label id=\"item_schedule_payee_name"+index+"\">"+payee_name+nick_name+"</label>"+
                    "<label id=\"item_schedule_account_number"+index+"\">"+bills_list_value.accountNumber+"</label>"+
                    "<label id=\"item_schedule_payee_id"+index+"\">"+bills_list_value.payeeId+"</label>"+
                    "<label id=\"item_earliest_payment_date"+index+"\">"+earliest_payment_date+"</label>"+
                    "<label id=\"last_payment_amount"+index+"\">"+last_payment_amount+"</label>"+
                    "<label id=\"last_payment_due_date"+index+"\">"+last_payment_date+"</label>"+
                    "<label id=\"last_payment_bill_status"+index+"\">"+last_payment_bill_status+"</label>"+
                    "<label id=\"is_show"+index+"\">"+true+"</label>"+                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
                    "</div>"+
                    "</a></li>";
            }
            else
            {
                schedule_payment_string += share_payment_string;
            }
           
		}
        // append html string to div_schedule
		$('#div_schedule>ul').append(schedule_payment_string);
        // bind tap event to each payee child
        $('#schedule_' + index).bind('click', function ()
        {
            if (is_item_line_double_click)
            {
                schedule_id = $(this).attr('id');
                selected_schedule_id = schedule_id.substring(schedule_id.indexOf("_") + 1);
                if(click_from_tab && selected_schedule_id == '1')
                {
                	click_from_tab = false;
                	return false;
                }
                else
                {
	                is_item_line_double_click = false;
	                var is_toolbar_enable = "DISABLE";
	                if (isSchedulePaymentChanged())
	                {
	                    is_toolbar_enable = "ENABLE";
	                }
	                goBackInfomations("PREVIEW_SCHEDULING_PAYMENT", is_toolbar_enable, $("#schedule_total_pay").val(), "Pay Bills", "YES", null);
	                JQT.goTo('#update_schedule', 'slide'); // animation
                }
            }
        });
    }
}

/**
 * Get deliver Data .
 * @param argDateType
 * @return string.
 */
function getDeliverDateStringExceptWeekDay(argDateType)
{
    var date_string = $('#txt_' + argDateType + '_deliver_date').val();
    return date_string.split(',')[1] + ',' + date_string.split(',')[2];
}

/**
 * compare the different date.
 */
function compareDeliveryDate()
{
    var date;
    var payment_deliver_date;
    if ($.trim(selected_pending_id).length != 0) 
    {
        date = $('#item_pending_date' + selected_pending_id).text();
        payment_deliver_date = getDeliverDateStringExceptWeekDay('pending');
        if ($.trim(payment_deliver_date) != $.trim(date)) 
        {
            $('#update_pending_payment').attr("disabled", "").removeClass("btn-disabled");
            return true;
        }
    }
    else if ($.trim(selected_schedule_id).length != 0) 
        {
            if ($.trim($('#item_schedule_date' + selected_schedule_id).text()).length != 0) 
            {
                date = $('#item_schedule_date' + selected_schedule_id).text();
            }
            else 
            {
                date = getCurrentDate();
            }
            
            payment_deliver_date = getDeliverDateStringExceptWeekDay('schedule');
            
            if ($.trim(payment_deliver_date) != $.trim(date)) 
            {
                $('#update_schedule_payment').attr("disabled", "").removeClass("btn-disabled");
                return true;
            }
            else 
            {
                $('#update_schedule_payment').attr("disabled", "disabled").addClass("btn-disabled");
            }
        }
    return false;
}

/***
 * get the money had payed.
 * @param argPayType
 * @return pay_money_value
 */
function getPayMoneyValue(argPayType)
{
    var pay_money_value = $('#txt_' + argPayType + '_pay_money_value').val();
    if (pay_money_value.length == 0) 
    {
        pay_money_value = $.trim($('#txt_' + argPayType + '_pay_money_value').attr('placeholder'));
    }
    return pay_money_value;
}


/**
 * verify the pay amount is changed or not .
 * @param argType
 * @return true or false
 */
function isUpdateButtonDisabled(argType)
{

    var is_pay_money_changed = false;
    var is_date_changed = compareDeliveryDate();
    var pay_money_value = getPayMoneyValue(argType);
    var price;
    if (argType.toUpperCase() == "SCHEDULE")
    {
        if ($.trim(selected_schedule_id).length != 0)
        {
            price = $('#item_schedule_price' + selected_schedule_id).text();
        }
    }
    else
    {
        if ($.trim(selected_pending_id).length != 0)
        {
            price = $('#item_pending_price' + selected_pending_id).text();
        }
    }
    if ($.trim(pay_money_value).length <= 0)
    {
        is_pay_money_changed = false;
    }
    var amount = pay_money_value.toString().replace(/\$|\,/g, '');
    if (isNaN(amount))
    {
        is_pay_money_changed = true;
    }
    if (price != null && $.trim(price).length == 0)
    {
        price = "0.00";
        is_pay_money_changed = false;
    }
    var fmt_current_amount = formatMoney(unFormatMoney(pay_money_value));
    if (formatMoney(unFormatMoney(price)) != fmt_current_amount && fmt_current_amount != 0)
    {
        is_pay_money_changed = true;
    }
    if (is_pay_money_changed)
    {
        return false;
    }
    if (is_date_changed && formatMoney(unFormatMoney(pay_money_value)) > 0)
    {
        return false;
    }
    return true;
}

/**
 * deal with OLTXWS connection errors
 */
function showOLTXWSConnectionError()
{
    goToErrorPage("oltx_ws_connection", 'Connection Error');
    return '0.0';
}

/**
 * deal with Fiserv connection errors.
 * @param argObj
 * @return true or false.
 */
function showFiservConnectionError(argObj)
{
    if ((argObj.BillPay !== undefined && argObj.BillPay.resultInfo !== undefined))
    {
        var value_array;
        if (argObj.BillPay.resultInfo.length !== undefined && argObj.BillPay.resultInfo.length != 0)
        {
            value_array = argObj.BillPay.resultInfo;
        }
        else
        {
            value_array = [argObj.BillPay.resultInfo];
        }
        for (var i = 0; i < value_array.length; i++)
        {
            if (value_array[i].category !== undefined && value_array[i].category.toUpperCase() != "INFO" || value_array[i].code == "371")
            {
                goToErrorPage(value_array[i].userMessage, 'Error');
            }
            else
            {
                if (value_array[i].userMessage === undefined)
                {
                    goToErrorPage("fiserv_connection", 'Connection Error');
                }
                else
                {
                    goToErrorPage(value_array[i].userMessage, 'Error');
                }

            }
            return false;
        }
    }
    else if (argObj.BillPay !== undefined && argObj.BillPay.resultInfo === undefined)
    {
        return true;
    }
    else
    {
        goToErrorPage('fiserv_connection', 'Connection Error');
        return false;
    }
    return true;
}

/**
 * deal with Fiserv connection errors.
 * @param argObj
 * @return true or false.
 */
function checkReturnedDataIsSuccessOrFailure(argObj)
{
    var value_array;
    if (argObj.BillPay.resultInfo !== undefined && argObj.BillPay.resultInfo.code == "371")
    {
        showFiservConnectionError(argObj);
        return false;
    }
    if (argObj.BillPay !== undefined && argObj.BillPay.paymentList !== undefined && argObj.BillPay.paymentList.payment !== undefined)
    {
        if (argObj.BillPay.paymentList.payment.length !== undefined && argObj.BillPay.paymentList.payment.length != 0)
        {
            value_array = argObj.BillPay.paymentList.payment;
        }
        else
        {
            value_array = [argObj.BillPay.paymentList.payment];
        }
        var index = 0;
        for (i = 0; i < value_array.length; i++)
        {
            var transaction_id = value_array[i].transactionId;
            if (transaction_id !== undefined && transaction_id.length > 0)
            {
                success_data_array[index] = transaction_id;
                index++;
            }
        }
        if (success_data_array.length == 0)
        {
            showFiservConnectionError(argObj);
            return false;
        }
        return true;
    }
    else
    {
        showFiservConnectionError(argObj);
        return false;
    }
    return true;
}

/**
 * set loading mask on the available balance text.
 */
function setLoadingMaskOnAvailableBalance()
{
    if (is_loading_pending) 
    {
        $('#div_pending>ul').empty();
        is_submit_pending = true;
    }
    if (is_loading_schedule) 
    {
        $('#div_schedule>ul').empty();
        is_submit_schedule = true;
    }
    $("#cash_available_to_withdraw").text("");
    $("#cash_available_to_withdraw").append(DASH_MARK);
    removeImageRotateCss();
}

/**
 * parse json message.
 * @param argJsonMsg
 * @return obj
 */
function parseJsonMsg(argJsonMsg)
{
	
    var obj = parseJson(argJsonMsg);
    // wi only user -- go to full screen error page
    if(obj == "timeout")
    {
        sessionTimeout();
    }
    else if ($.trim(argJsonMsg).length == 0 || obj === undefined || obj == null || !obj ) 
    {
        goToErrorPage('fiserv_connection', 'Connection Error');
    }
    return obj;
}

function parseJson(argJsonMsg)
{
    try
    {
        if(argJsonMsg.indexOf(TIME_OUT_PARAMETER) >= 0 && argJsonMsg.indexOf(TIME_OUT_LOGIN_PARAMETER) >= 0 && $.trim(argJsonMsg).indexOf('<!DOCTYPE')  >= 0)
        {
            return "timeout";
        }
        return jQuery.parseJSON(argJsonMsg);
    }
    catch (e)
    {
        return false;
    }
}

function sessionTimeout()
{
	sendRequestToContainer(Messages.SESSION_TIMEOUT,null);
}
/**
 * Give the account box to add shadow.
 */
function addAccountBoxShadow(){
    $('#txt_accounts_list').removeClass().addClass("virtual-select");
}

function removeAccountBoxShadow(){
    $('#txt_accounts_list').removeClass().addClass("virtual-select-white");
}

/**
 * 
 * @param argType
 * @return
 */
function addDateBoxShadow(argType)
{
	if(argType.toUpperCase() == "SCHEDULE")
	{
	    $('#txt_schedule_deliver_date').removeClass().addClass("virtual-select");
	}
	else if(argType.toUpperCase() == "PENDING")
	{
	    $('#txt_pending_deliver_date').removeClass().addClass("virtual-select");
	}
}

function removeDateBoxShadow()
{  
    $('#txt_schedule_deliver_date').removeClass().addClass("virtual-select-white");
    $('#txt_pending_deliver_date').removeClass().addClass("virtual-select-white");
}

/**
 * 
 * @param argType
 * @return autopay || recurringdat.
 */
function isWarningMessageVisible(argType)
{
    var autopay = false,
        recurringdate = false;
    if (argType.toUpperCase() == "SCHEDULE")
    {
        autopay = $('#schedule_warn').css('display') == "none" ? false : true;
        recurringdate = $('#schedule_warn_delivery_date').css('display') == "none" ? false : true;
    }
    else if (argType.toUpperCase() == "PENDING")
    {
        autopay = $('#pending_warn').css('display') == "none" ? false : true;
        recurringdate = $('#warn_delivery_date').css('display') == "none" ? false : true;
    }
    return autopay || recurringdate;
}

function isPaymentChanged()
{
	if ($.trim($("#confirmation_info").attr("class")) == "current")
    {
        return "NO";
    }
    if ($("#tab_bar_pending").hasClass('select')) 
    {
        return isPendingPaymentChanged() ? "YES" : "NO";
    }
    else 
    {
        return isSchedulePaymentChanged() ? "YES" : "NO";
    }
}

function isSchedulePaymentChanged()
{
    var schedule_data_length = $('#div_schedule>ul>li').length;
    for (var i = 0; i < schedule_data_length; i++) 
    {
        if ($('#item_schedule' + (i + 1)).hasClass('added')) 
        {
            return true;
        }
    }
    return false;
}

function isPendingPaymentChanged()
{
    var pending_data_length = $('#div_pending>ul>li').length;
    for (var i = 0; i < pending_data_length; i++) 
    {
        if (!$('#div_item_pending_price' + (i + 1)).hasClass('pending')) 
        {
            return true;
        }
    }
    return false;
}

function cancelPayment()
{
    //show loading spinners.so that loading data
	is_execute_spinner = false;
    showLoadingSpinners();
	is_click_brokerage_account = false;
    removeImageRotateCss();
    if ($('#tab_bar_schedule').hasClass('select'))
    {
        $('#div_schedule>ul').empty();
        switchPages("PREVIEW_SCHEDULING_PAYMENT", "DISABLED", "0.00", "Pay Bills", "YES", "YES");
    }
    else
    {
        $('#div_pending>ul').empty();
        switchPages("PREVIEW_PENDING_PAYMENT", "DISABLED", $("#pending_total_pay").val(), "Pay Bills", "YES", "YES");
    }
    page_transition_stack = [];
    JQT.goBack("#home");
}

/**
 * delete payment when use exit pay bills 
 * 
 * @return
 */
function deletePayment()
{
    //show loading spinners.so that loading data
	is_execute_spinner = false;
    showLoadingSpinners();
	is_click_brokerage_account = false;
    removeImageRotateCss();
    if (isSchedulePaymentChanged())
    {
    	$('#div_schedule>ul').empty();	
        switchPages("PREVIEW_SCHEDULING_PAYMENT", "DISABLED", "0.00", "Pay Bills", "YES", "YES");
    }	
	if (isPendingPaymentChanged())
	{
		$('#div_pending>ul').empty();	
	    switchPages("PREVIEW_PENDING_PAYMENT", "DISABLED", $("#pending_total_pay").val(), "Pay Bills", "YES", "YES");
	}	
        	        
    page_transition_stack = [];    
}

function isSchedulePaymentSingleChanged()
{
    var total_change_num = 0;
    $("div[id ^= 'item_schedule']").each(function(i, obj)
    {
        if ($(obj).text() != 'Schedule') 
        {
            total_change_num++;
        }
    });
    
    if (total_change_num == 1) 
    {
        return true;
    }
    return false;
}

function isPendingPaymentSingleChanged()
{
    var total_change_num = 0;
    var preview_payment_list_length = $("#div_pending>ul>li").length;
    for (var i = 1; i <= preview_payment_list_length; i++) 
    {
        var price = $("#item_pending_price" + i).text();
        var new_price = $("#item_pending_new_price" + i).text();
        var date_string = $.trim($("#item_pending_date" + i).text());
        var new_date_string = $.trim($("#item_pending_new_date" + i).text());
        if (price != new_price || date_string != new_date_string) 
        {
            total_change_num++;
        }
    }
    
    if (total_change_num == 1) 
    {
        return true;
    }
    return false;
}


/**
 * format number.
 * @param argNum
 * @return format number.
 */
function formatNumber(argNum)
{
	argNum = argNum.toString().replace(/\$|\,/g, '');
    if (isNaN(argNum) || $.trim(argNum).length == 0) 
    {
    	argNum = "0";
    }
    var sign = (argNum == (argNum = Math.abs(argNum)));
    argNum = Math.floor(argNum * 100 + 0.50000000001);
    var cents = argNum % 100;
    argNum = Math.floor(argNum / 100).toString();
    if (cents < 10) 
    {
        cents = "0" + cents;
    }
    for (var i = 0; i < Math.floor((argNum.length - (1 + i)) / 3); i++) 
    {
    	argNum = argNum.substring(0, argNum.length - (4 * i + 3)) + ',' + argNum.substring(argNum.length - (4 * i + 3));
    }
    return (((sign) ? '' : '-') + argNum + '.' + cents);
}

/**
 * format currency to double number.
 * @param argNum
 * @return float num.
 */
function unFormatMoney(argNum)
{
    if ($.trim(argNum).length == 0) 
    {
    	argNum = '0.0';
    }
    var priceNum = argNum.replace(/\,/g, '');
    return parseFloat(priceNum);
}

/**
 * format currency to two decimal.
 * @param argNum
 * @return  fixed num.
 */
function formatMoney(argNum)
{
    return argNum.toFixed(2);
}

/**
 * 
 * @param argDateString
 * @return date.
 */
function formatDate(argDateString)
{
    if (argDateString !== undefined && $.trim(argDateString).length != 0)
    {
        var date_array = argDateString.split(' ')[0].split('-');
        var year = ' ' + date_array[0];
        var month = MONTH_CONVERTOR[date_array[1]] + ' ';
        var date = parseInt(date_array[2], 10) + ',';
        return month + date + year;
    }
    return "";
}

/**
 * 
 * @param argDate
 * @return date string.
 */
function getDateDetail(argDate)
{
    var date_obj = $.trim(argDate);
    var date_string = date_obj.toString().replace(/\s/g, '');
    var date_array = [];
    if (date_obj.length != 0) 
    {
        date_array.push(parseInt(MONTH_CONVERTOR_DISORDER[date_string.substring(0, 3)],10));
        date_array.push(parseInt(date_string.substring(3, date_string.indexOf(',')),10));
        date_array.push(parseInt(date_string.split(',')[1],10));
    }
    return date_array;
}

/**
 * date format:DEC 3, 2010.
 * @param argDeliveryDate
 * @param argDeliveryUpdatedDate
 * @return compared result
 */
function compareFormatDate(argDeliveryDate, argDeliveryUpdatedDate)
{
    var delivery_array = getDateDetail(argDeliveryDate);
    var update_array = getDateDetail(argDeliveryUpdatedDate);
    var compare_result = compareTwoNumber(delivery_array[2], update_array[2]);
    if (compare_result == "equal") 
    {
        compare_result = compareTwoNumber(delivery_array[0], update_array[0]);
        if (compare_result == "equal") 
        {
            compare_result = compareTwoNumber(delivery_array[1], update_array[1]);
            if (compare_result == "equal") 
            {
                return false;
            }
        }
    }
    return compare_result;
}

/**
 * 
 * @param argNum1
 * @param argNum2
 * @return true or false.
 */
function compareTwoNumber(argNum1, argNum2)
{
    if (argNum1 > argNum2) 
    {
        return true;
    }
    else if (argNum1 == argNum2) 
        {
            return "equal";
        }
        else 
        {
            return false;
        }
}

/**
 * 
 * @param argDate
 */
function getWeekDay(argDate)
{
    var date_detail = getDateDetail($.trim(argDate));
    var temp_date = new Date(date_detail[2], date_detail[0] - 1, date_detail[1]);
    return WEEK_DAY[temp_date.getDay()];
    
}
/**
 * 
 * @param argFormatDate
 */
function getSubmitFormatDate(argFormatDate)
{
    var date_array = getDateDetail(argFormatDate);
    if (date_array.length != 0) 
    {
        if (date_array[0] > 0 && date_array[0] < 10) 
        {
            date_array[0] = '0' + date_array[0];
        }
        if (date_array[1] > 0 && date_array[1] < 10) 
        {
            date_array[1] = '0' + date_array[1];
        }
        return date_array[2] + '-' + date_array[0] + '-' + date_array[1];
    }
    return "";
}

function getCurrentDate()
{
    var nextYear = new Date();
    var month = nextYear.getMonth() + 1;
    var day = nextYear.getDate();
    var year = nextYear.getFullYear();
    if (month < 10) 
    {
        month = "0" + month;
    }
    var date = MONTH_CONVERTOR[month] + " " + day + ", " + year;
    return date;
}

/**
 * 
 * @param argAccountNumber
 */
function getMaskedAccountNumber(argAccountNumber)
{
    var mask_string = "<span>*</span>";
    if ($.trim(argAccountNumber).length != 0 && $.trim(argAccountNumber).length > 5)
    {
        return mask_string + argAccountNumber.substring(argAccountNumber.length - 5);
    }
    else if ($.trim(argAccountNumber).length == 0)
    {
        return argAccountNumber;
    }
    else
    {
        return mask_string + argAccountNumber;
    }
}

/**
 * 
 * @param argAccountNumber
 */
function getMaskedAccountNumberWithParenthesis(argAccountNumber)
{
    var mask_string = "(*";
    if ($.trim(argAccountNumber).length != 0 && $.trim(argAccountNumber).length > 5)
    {
        return mask_string + argAccountNumber.substring(argAccountNumber.length - 5) + ')';
    }
    else if ($.trim(argAccountNumber).length == 0)
    {
        return '(' + argAccountNumber + ')';
    }
    else
    {
        return mask_string + argAccountNumber + ')';
    }
}

/**
 * 
 * @param argWholeAccountNumber
 */
function getAccountNumber(argWholeAccountNumber)
{
    return argWholeAccountNumber.substring(argWholeAccountNumber.lastIndexOf('(') + 1, argWholeAccountNumber.length - 1);
}

/**
 * 
 * @param argJson
 * @return
 */
function setPendingChangesConfirmation(argJson)
{
    $('#confirmation_header').empty().append(PENDING_CONFIRMATION_HEADER_MSG);
    var obj = parseJsonMsg(getConfirmationOfPendingChangeList());
    $("#confirmation_info_content").empty();
    var error_account_arr = "";
    var temp_point = 1;
    $(obj.confirmation).each(function(i)
    {
        var con = obj.confirmation[i];
        var account = obj.confirmation[i].Account;
        var payee = obj.confirmation[i].Payee;
        var amount = obj.confirmation[i].Amount;
        var deliverBy = obj.confirmation[i].DeliverBy;
        var transactionid = obj.confirmation[i].TransactionId;
        var confirmationnumber = obj.confirmation[i].ConfirmationNumber;
        var is_successful = true;
        for (i = 0; i < success_data_array.length; i++)
        {
            if (transactionid.toUpperCase() == success_data_array[i].toUpperCase())
            {
                is_successful = false;
                var append_html_string = 
                    "<article>" +
                    "<div class=\"title-bar\">" +
                    "<div class=\"inner\">" +
                    "<a>CHANGE "+temp_point+"</a>" +
                    "</div>" +
                    "</div>"+ 
                    "<ul class=\"ul-pay\" name=\"ul_confirmation\">" +
                    "<li class=\"even-row\">" +
                    "<div class=\"content-left\">Account</div>"+
                    "<div class=\"content-right\" id=\"changes_account+"+temp_point+"\">"+account+"</div>" +
                    "</li>" +
                    "<li class=\"old-row\">" +
                    "<div class=\"content-left\">Payee</div>" +
                    "<div class=\"content-right\" id=\"changes_payee+"+temp_point+"\">"+payee+"</div>" +
                    "</li>" +
                    "<li class=\"even-row\">" +
                    "<div class=\"content-left\">Amount</div>" +
                    "<div class=\"content-right\" id=\"div_right_content\">"
                    +amount +
                    "</div>" +
                    "</li>" +
                    "<li class=\"old-row\">"+
                    "<div class=\"content-left\">Deliver By</div>" +
                    "<div class=\"content-right\" id=\"div_right_content\">"+
                    "<span class=\"text-decoration-none\" id=\"changes_deliverby"+temp_point+"\">"+deliverBy+"</span>" +
                    "</div>" +
                    "</li>"+
                    "<li class=\"even-row\">"+
                    "<div class=\"content-left\">Confirmation #</div>" +
                    "<div class=\"content-right\" id=\"div_right_content\">"+
                    "<span style=\"text-decoration:none;\" id=\"changes_confirmation"+temp_point+"\">"+confirmationnumber+"</span>" +
                    "</div>" +
                    "</li>" +
                    "</ul>" +
                    "</article>";
                temp_point++;
            }
        }
        if (is_successful) 
        {
            error_account_arr += account + ","
        }
        $("#confirmation_info_content").append(append_html_string);
    });
    if (success_data_array.length != (temp_point - 1)) 
    {
        if (error_account_arr != "") 
        {
            error_account_arr = error_account_arr.substring(0, error_account_arr.length - 1);
        }
        $("#hide_error_accounts").val(error_account_arr);
        $("#warn_confirmation_info").text(WARN_CONFIRMATION_MSG);
        $("#warn_confirmation").show();
    }
}

/**
 * 
 * @param argJson
 */
function goToPendingPaymentConfirmationPage(argJson)
{
    var obj = parseJsonMsg(argJson);
    var is_none_error_return = true;
    if (!obj) 
    {
        goToErrorPage("fiserv_connection", 'Connection Error');
        return;
    }
    else 
    {
        is_none_error_return = checkReturnedDataIsSuccessOrFailure(obj);
    }
    if (is_none_error_return) 
    {
    	confirmation_json = obj;
        JQT.goTo('#confirmation_info', 'slide');
        page_transition_stack = [];
        confirmation = "pending";
        switchPages("", "", "", "Confirmation", "NO", "NO");
        
    }
    
}

function getConfirmationOfPendingChangeList()
{
	var json_string = "{\"confirmation\":[";
    $("article[name = 'art_pending']").each(function (i)
    {
        var index = i + 1;
        json_string +="{" +
			"\"Account\":\""+$('#changes_account'+index).text() +"\","+
			"\"Payee\":\""+$('#changes_payee'+index).text() +"\","+
			"\"Amount\":\""+$('#changes_amount'+index).text() +"\","+
			"\"DeliverBy\":\""+$('#changes_deliverby'+index).text() +"\","+
			"\"TransactionId\":\""+$('#preview_pending_transaction_id'+index).text() +"\","+
			"\"ConfirmationNumber\":\""+$('#preview_pending_confirmation_number'+index).text() +"\""+
			"},";
    });
    json_string = json_string.substring(0, json_string.length - 1);
    json_string += "]}";
    $("#preview_changes").empty();
    
    return json_string;
}

function getConfirmationOfSchedulePaymentList()
{
	var json_string = "{\"confirmationSchedule\":[";
    $("article[name^='art_schedule_confirmation']").each(function (i)
    {
        var index = i + 1;
        json_string +="{" +
			"\"Account\":\""+$('#payment_account'+index).text() +"\","+
			"\"Payee\":\""+$('#payment_payee'+index).text() +"\","+
			"\"Amount\":\""+$('#payment_amount'+index).text() +"\","+
			"\"DeliverBy\":\""+$('#payment_deliverby'+index).text() +"\""+
			"},";
    });
    json_string = json_string.substring(0, json_string.length - 1);
    json_string += "]}";
    return json_string;
}

/**
 * 
 * @param argJson
 */
function setSchedulePaymentConfirmation(argJson)
{
    $('#confirmation_header').text(SCHEDULE_CONFIRMATION_HEADER_MSG);
    var return_result_obj = argJson.BillPay.paymentList.payment;
    var obj = parseJsonMsg(getConfirmationOfSchedulePaymentList());
    $("#confirmation_info_content").empty();
    var temp_point = 1;
    var error_account_arr = "";
    var is_include_error = false;
    $(obj.confirmationSchedule).each(function(i)
    {
        var item = obj.confirmationSchedule[i];
        var account = item.Account;
        var payee = item.Payee;
        var amount = item.Amount;
        var deliverby = item.DeliverBy;
        var confirmation_number;
        if (return_result_obj.length !== undefined) 
        {
            confirmation_number = return_result_obj[i].confirmationNumber;
        }
        else 
        {
            confirmation_number = return_result_obj.confirmationNumber;
            if (confirmation_number === undefined) 
            {
                confirmation_number = "FAIL";
            }
        }
       if (confirmation_number != "FAIL" && confirmation_number !== undefined)
        {
            var append_html_string = 
                "<article>" +
                "<div class=\"title-bar\">" +
                "<div class=\"inner\">" +
                "<a>PAYMENT "+temp_point+"</a>" +
                "</div>" +
                "</div>"+ 
                "<ul class=\"ul-pay\" name=\"ul_confirmation\">" +
                "<li class=\"even-row\">" +
                "<div class=\"content-left\">Account</div>"+
                "<div class=\"content-right\" id=\"payment_account"+temp_point+"\">"+account+"</div>" +
                "</li>" +
                "<li class=\"old-row\"><div class=\"content-left\">Payee</div>" +
                "<div class=\"content-right\" id=\"payment_payee"+temp_point+"\">"+payee+"</div>" +
                "</li>" +
                "<li class=\"even-row\">" +
                "<div class=\"content-left\">Amount</div>" +
                "<div class=\"content-right\">"+
                "<span class=\"text-decoration-none font-weight-bold\" id=\"payment_amount"+temp_point+"\">"+amount+"</span>" +
                "</div>" +
                "</li>" +
                "<li class=\"old-row\">"+
                "<div class=\"content-left\">Deliver By</div>" +
                "<div class=\"content-right\">"+
                "<span class=\"text-decoration-none\" id=\"payment_deliverby"+temp_point+"\">"+deliverby+"</span>" +
                "</div>" +
                "</li>" +
                "<li class=\"even-row\">"+
                "<div class=\"content-left\">Confirmation #</div>" +
                "<div class=\"content-right\">"+
                "<span class=\"text-decoration-none\" id=\"payment_confirmation_number"+temp_point+"\">"+confirmation_number+"</span>" +
                "</div>" +
                "</li>" +
                "</ul>" +
                "</article>";
            temp_point++;
        }
        else
        {
            error_account_arr += account + ",";
            is_include_error = true;
        }
        $("#confirmation_info_content").append(append_html_string);
    });

    if (is_include_error) 
    {
        if (error_account_arr != "") 
        {
            error_account_arr = error_account_arr.substring(0, error_account_arr.length - 1);
        }
        $("#hide_error_accounts").val(error_account_arr);
        $("#warn_confirmation_info").empty().text(WARN_CONFIRMATION_MSG);
        $("#warn_confirmation").show();
    }
}

/**
 * 
 * @param argJson
 */
function goToSchedulePaymentConfirmationPage(argJson)
{
    var obj = parseJsonMsg(argJson);
    
    var is_result_error_returned = true;
    if (!obj) 
    {
        goToErrorPage("fiserv_connection", 'Connection Error');
        return;
    }
    else 
    {
        is_result_error_returned = checkReturnedDataIsSuccessOrFailure(obj);
    }
   
    if (is_result_error_returned) 
    {
    	confirmation_json = obj;
        JQT.goTo('#confirmation_info', 'slide');
        page_transition_stack = [];
        confirmation = "schedule";
        switchPages("", "", "", "Confirmation", "NO", "NO");
    }
}

function handlePendingWarnInfo()
{
    if ($('#pending_lbl_auto_pay' + selected_pending_id).text() == "AUTO PAY")
    {
        $("#pending_warn").show();
        $("#pending_hide_warn_messages").val(HIDE_PENDING_WARN_MSG);
        $('#informational_message').text($("#pending_hide_warn_messages").val());
    }
    else if ($('#item_pending_recurring' + selected_pending_id).text().length > 0)
    { // if content include recurring item.
        $("#pending_warn").show();
        $("#pending_hide_warn_messages").val($('#item_pending_recurring' + selected_pending_id).text());
        $('#informational_message').text($("#pending_hide_warn_messages").val());
    }
    else
    {
        $("#pending_warn").hide();
        $("pending_hide_warn_messages").val("");
    }
}

function handleSchedualWarnInfo()
{
    // If autoPay.then display the importance message.
    if ($('#schedule_lbl_auto_pay' + selected_schedule_id).text() == "AUTO PAY") 
    {
        $("#schedule_warn").show();
        $("#schedule_hide_warn_messages").val(HIDE_SCHEDULE_WARN_MSG);
        $('#schedule_informational_message').text($("#schedule_hide_warn_messages").val());
    }
    else 
    {
        $("#schedule_warn").hide();
        $("schedule_hide_warn_messages").val("");
    }
}

/**
 * 
 * verify load data or not.
 */
function isLoadData()
{
    var account = $("#hide_whole_selected_account").val();
    var account_number = getAccountNumber(account);

    var hide_account = $("#hide_selected_account").val();
    var hide_account_number = getAccountNumber(hide_account);
    if (hide_account_number == null || hide_account_number.length <= 0)
    {
        return "YES";
    }
    var is_load_new_data = "YES";

    if ($.trim(account_number) == $.trim(hide_account_number))
    {
        if (!is_submit_pending)
        {
            is_submit_pending = true;
            return "YES";
        }
        if (!is_submit_schedule)
        {
            is_submit_schedule = true;
            return "YES";
        }
        if (is_loading_pending && $.trim($('#div_pending>ul').html()) == "" )
        {
            return "YES";
        }
        if (is_loading_schedule && $.trim($('#div_schedule>ul').html()) == "")
        {
            return "YES";
        }

        is_load_new_data = "NO";
    }
    return is_load_new_data;
}

/**
 * verify whether the payee earliest date has been cached
 * @return
 */
function isEarliestDateCached(){
    var account = $("#hide_whole_selected_account").val();
    var account_number = getAccountNumber(account);
    
    if($.trim($('#hide_shcedule_payment_string').val()).length == 0){
        return true;
    }
    var obj = parseJsonMsg($.trim($('#hide_shcedule_payment_string').val()));
    var json_account_name = "";
    
    if (typeof obj == "object" && obj.BillPay !== undefined && obj.BillPay.selectedAccount !== undefined)
    {
        json_account_name = obj.BillPay.selectedAccount;
         if ( account_number == json_account_name)
        {
            return false;
        }
    }
    return true;
    
}

/**
 * get the payee earliest date with payeeId
 * @param payeeId
 * @return
 */
function getPendingPaymentEarliestDate(payeeId){
    var message = $('#hide_shcedule_payment_string').val();
    //parse schedule payment json string to js obj    
    var obj = parseJsonMsg(message);
    //'payment array obj' in obj
    var schedule_payment_array_obj;
    if (obj.BillPay !== undefined && obj.BillPay.paymentList !== undefined && obj.BillPay.paymentList.payment !== undefined && obj.BillPay.paymentList.payment.length != 0)
    {
        //get payment array obj
        schedule_payment_array_obj = obj.BillPay.paymentList.payment;
         for (var i = 0; i < schedule_payment_array_obj.length; i++)
        {
            if(schedule_payment_array_obj[i].payee.payeeId == payeeId)
            {
                return schedule_payment_array_obj[i].payee.earliestPaymentDate;
            }
        }
    }
    return "";
}

function showBillPayUnavailableError()
{
    goToErrorPage('unavailable_error', 'BillPay Unavailable');
}

/**
 * initial data
 */
function removeImageRotateCss(){
	clearTimeout(rotate_delay);
	rotate_delay = setTimeout(function()
	{
		$(".activity-animation-running").removeClass("activity-animation-running");
	},10000);
}

$(document).ready(function ()
{
    setLoadingMaskOnAvailableBalance();
    // initial schedule payment toolbar. set the top toolbar and bottom toolbar.
    switchPages("PREVIEW_SCHEDULING_PAYMENT", "DISABLE", "0.00", "Pay Bills", "YES", "YES");
    // click button (Continue Using BillPay) ,cancel modal window.
    $('#continue_billpay').live('click', function ()
    {
        is_closed_modal = false;
        $('#home').css('height', 'auto');
        // reset the toolbar.
        showToolBar();
        // close the pop-up modal window.
        if ($("#hide_is_show_account_history").val().toUpperCase() == "YES")
        {
            $("#hide_is_show_account_history").val("");
        }
    });

    // click button (Delete payments),exit the whole program.
    $('#delete_payments').live('click', function ()
    {
        // exit the whole program
        is_closed_modal = false;
        var account = null;
        if ($("#hide_is_show_account_history").val().toUpperCase() == "YES")
        {
            account = getAccountNumber($("#txt_accounts_list").val());
        }
        exitBillPay(account);
    });

    // get one account from account list of select tag.
    $("#txt_accounts_list").unbind("click");
    $("#txt_accounts_list").bind("click" /**
												 * click event does not work for
												 * input tag
												 */ , function (e)
    {
		is_execute_spinner = true;
        var account_list = $.trim($("#txt_accounts_list").val());
        if (account_list != "" && account_list.toUpperCase() != ACCOUNT_LOADING_MSG)
        {
            is_loading_schedule = true;
            is_loading_pending = true;
            is_click_brokerage_account = true;
            addAccountBoxShadow();
            setTimeout(function()
            {
            	showBrokerageAccountsList(getBillpayAccounts());
            },10);
        }
        // }
    });
    $('.inner').live('touchstart',function(){click_from_tab = true;});
    $('.tab-bar').live('touchstart',function(){click_from_tab = true;});
    $("#tab_bar_pending").live('touchstart', function ()
    {
    	is_click_brokerage_account = false;
    	click_from_tab = false;
        if (!$(this).hasClass("select"))
        {
        	$("#pending_see_history_info").show();
            pendingClickHandler();
            is_loading_pending = true;
            is_loading_schedule = false;
            var is_enable = "ENABLE";
            var is_load = "YES";
            if (isLoadData() == "YES")
            {
                $('#div_pending>ul').empty();
                is_load = "YES";
                //show loading spinners.so that loading data
                showLoadingSpinners();
                removeImageRotateCss();
                is_enable = "DISABLE";
            }
            else
            {
                is_loading_pending = false;
                $("#cash_available_to_withdraw").text($("#hide_cash_available_to_withdraw").val());
                hideLoadingSpinners();
                is_load = "NO";
                if (isPendingPaymentChanged())
                {
                    is_enable = "ENABLE";

                }
                else
                {
                    is_enable = "DISABLE";

                }
            }
            countTotalPayOfPendingPayment();
            var amount = "0.00";
            if (is_load != "YES")
            {
                amount = $("#pending_total_pay").val();
            }
            switchPages("PREVIEW_PENDING_PAYMENT", is_enable, amount, "Pay Bills", "YES", is_load);
            
        }
    });
    $("#tab_bar_schedule").live("touchstart", function ()
    {
    	is_click_brokerage_account = false;
    	click_from_tab = false;
        if (!$(this).hasClass("select"))
        {
            // update the style.
            scheduleClickHandler();
            is_loading_schedule = true;
            is_loading_pending = false;
            var is_load = "YES";
            if (isLoadData() == "YES")
            {
                $('#div_schedule>ul').empty();
                is_load = "YES";
                //show loading spinners.so that loading data
                showLoadingSpinners();
                removeImageRotateCss();
                is_enable = "DISABLE";
            }
            else
            {
            	hideLoadingSpinners();
                $("#cash_available_to_withdraw").text($("#hide_cash_available_to_withdraw").val());
                is_loading_schedule = false;
                is_load = "NO";
                if (isSchedulePaymentChanged())
                {
                    is_enable = "ENABLE";
                }
                else
                {
                    is_enable = "DISABLE";

                }
            }
//            if (is_load != "YES")
//            {
	            if ($("#tab_bar_pending").hasClass("select"))
	            {
	                $("#pending_see_history_info").show();
	            }else
	            {
	            	$("#pending_see_history_info").hide();
	           }
           // }
            countTotalPayOfSchedulePayment();
            switchPages("PREVIEW_SCHEDULING_PAYMENT", is_enable, $('#schedule_total_pay').val(), "Pay Bills", "YES", is_load);
         
        }
    });

    // According to isGoBack value ,finish the page go back result.
    $('#home').bind('pageAnimationEnd', function (e, info)
    {
    	click_from_tab = false;
        $("#txt_schedule_pay_money_value").val("");
        $('#txt_pending_pay_money_value').val("");
        if (info.direction == "in")
        {
            is_error_pending_submit = false;
            is_error_schedule_submit = false;
            if (is_back_to_schedule_tab)
            {
                // remove the array record that the index equal (its length -1).
                page_transition_stack.pop(page_transition_stack.length - 1);

                // verify whether click the cancel button on the update payment page.
                if (is_cancle_schedule)
                {
                    page_transition_stack.pop(page_transition_stack.length - 1);
                    // remove style of schedule button
                    $('#item_schedule' + selected_schedule_id).removeClass().addClass("schedule sub").text("Schedule");

                    if ($('#is_show' + selected_schedule_id).text() == "true")
                    {
                        if ($('#last_payment_bill_status' + selected_schedule_id).text().toUpperCase() == "UNPAID")
                        {
                            $('#last_payment_label' + selected_schedule_id).text("");
                            $('#item_label' + selected_schedule_id).text("due");
                            $('#item_schedule_price' + selected_schedule_id).text($('#ebill_amount_due' + selected_schedule_id).text());
                            $('#item_schedule_date' + selected_schedule_id).text($('#ebill_due_date' + selected_schedule_id).text());
                        }
                        else
                        {
                            $('#last_payment_label' + selected_schedule_id).text("Last Payment: ");
                            $('#item_label' + selected_schedule_id).text("on");
                            $('#item_schedule_price' + selected_schedule_id).text($('#last_payment_amount' + selected_schedule_id).text());
                            $('#item_schedule_date' + selected_schedule_id).text($('#last_payment_due_date' + selected_schedule_id).text());
                        }
                    }
                    else
                    {
                        $('#last_payment_label' + selected_schedule_id).text("");
                        $('#item_label' + selected_schedule_id).text("");
                        $('#item_schedule_price' + selected_schedule_id).text("");
                        $('#item_schedule_date' + selected_schedule_id).text("");
                        $('#lbl_symbol' + selected_schedule_id).text("");
                    }
                    // set preview changes button enable.
                    is_cancle_schedule = false;
                    selected_schedule_id = '';
                }
                // verify whether click the update button on the update payment
				// page.
                if (is_update_schedule)
                {
                    $('#last_payment_label' + selected_schedule_id).text("");
                    // set deliver date.
                    $('#item_schedule_date' + selected_schedule_id).text(payment_deliver_date);
                    if ($('#lbl_symbol' + selected_schedule_id).text() == "")
                    {
                        $('#lbl_symbol' + selected_schedule_id).text("$");
                    }
                    // remove style of schedule button
                    $('#item_schedule' + selected_schedule_id).removeClass().addClass("added sub");
                    // change label due to Delivery Date
                    $('#item_label' + selected_schedule_id).text("Deliver by:");
                    // set value
                    var money = $.trim(formatNumber(parseFloat(unFormatMoney(amount_on_update_button))));
                    $('#item_schedule' + selected_schedule_id).text("$" + money);
                    $('#item_schedule_price' + selected_schedule_id).text(money);
                    selected_schedule_id = '';
                    is_update_schedule = false;
                }
                // set isGoBack variable equal false
                is_back_to_schedule_tab = false;
            }

            if (is_back_to_pending_tab)
            {

                $('#pending_' + selected_pending_id).removeClass("blue").addClass("color666 color333");
                page_transition_stack.pop(page_transition_stack.length - 1);

                // cancel pending payment
                if (is_cancle_pending)
                {
                    // remove style of schedule button
                    $('#div_item_pending_price' + selected_pending_id).removeClass().addClass("cancel-pending sub");
                    $('#item_pending_price' + selected_pending_id).removeClass().addClass("cancel-price");
                    $("#symbol" + selected_pending_id).empty();
                    $("#item_pending_price" + selected_pending_id).text("CANCEL");
                    selected_pending_id = '';
                    is_cancle_pending = false;
                }
                // update payment
                if (is_update_pending)
                {
                    // initial money value
                    var init_money_val = $('#item_pending_new_price' + selected_pending_id).text();
                    var init_date_val = $.trim($('#item_pending_new_date' + selected_pending_id).text());
                    var update_date_val = $.trim(payment_deliver_date);
                    var money = $.trim(amount_on_update_button);
                    var temp_init_money_val = init_money_val.replace(',', '');
                    var temp_money = money.replace(',', '');
                    if ($.trim($("#symbol" + selected_pending_id).text()).length <= 0)
                    {
                        $("#symbol" + selected_pending_id).text("$");
                    }
                    // if the initial amount equal the input amount ,or the
					// initial deliver date equal input date
                    if (parseFloat($.trim(temp_init_money_val)) != parseFloat($.trim(temp_money)) || init_date_val != update_date_val)
                    {
                        $('#div_item_pending_price' + selected_pending_id).removeClass().addClass("pending-added sub");
                    }
                    else
                    {
                        $('#div_item_pending_price' + selected_pending_id).removeClass().addClass("pending sub");
                    }
                    $('#item_pending_price' + selected_pending_id).removeClass().addClass("pending-price").text($.trim(formatNumber(parseFloat(unFormatMoney(money)))));
                    $('#item_pending_date' + selected_pending_id).text("  " + update_date_val);
                    is_update_pending = false;
                    selected_pending_id = '';
                }
                // set isGoBack variable equal false
                is_back_to_pending_tab = false;
            }
            is_closed = false;
        }

    });



    $('#confirmation_info').bind('pageAnimationStart', function (e, info)
    {
        if (info.direction == "in")
        {
        	
        	if(init_confirmation_loading){
        		init_confirmation_loading = false;
                $('#view_pending_payments').live("click", function ()
                {
                	is_click_billpay_error_page = true;
                	is_execute_view_pending_payments = true;
                	is_execute_pay_more_bills = false;
                    is_closed = true;
                    pendingClickHandler();
                    is_submit_pending = false;
                    is_submit_schedule = false;
                    is_loading_pending = true;
                    is_loading_schedule = false;
                    is_execute_spinner = false;
                    $("#pending_see_history_info").show();
                    setLoadingMaskOnAvailableBalance();
                    $('#div_pending>ul').empty();
                    confirmation = "";
                    JQT.goBack("#home");
                });
                $('#pay_more_bills').live("click", function ()
                {
                	is_click_billpay_error_page = true;
                	is_execute_pay_more_bills = true;
                	is_execute_view_pending_payments = false;
                    scheduleClickHandler();
                    is_submit_pending = false;
                    is_submit_schedule = false;
                    is_closed = true;
                    is_loading_pending = false;
                    is_loading_schedule = true;
                    is_execute_spinner = false;
                    $("#pending_see_history_info").hide();
                    setLoadingMaskOnAvailableBalance();
                    $('#div_schedule>ul').empty();
                    confirmation = "";
                    JQT.goBack("#home");
                });
                $("#warn_confirmation").live("touchstart", function ()
                {
                    JQT.goTo("#billpay_error", 'slide');
                    switchPages("", "DISABLE", "0.00", "BillPay Error", "NO", "NO");
                });

            }
        }
    });

    $('#confirmation_info').bind('pageAnimationEnd', function (e, info)
    {
        if (info.direction == "in")
        {
            if (confirmation == "pending")
            {
                setPendingChangesConfirmation(confirmation_json);
            }
            else if (confirmation == "schedule")
            {
                setSchedulePaymentConfirmation(confirmation_json);
            }
            $('ul[name="ul_confirmation"]:last').addClass('last-border');
            confirmation_json = "";
            var footer_info = 
                "<div class=\"gray-border\">"+
				"<input type=\"button\" class=\"green primary\" value=\"Pay More Bills\" id=\"pay_more_bills\">"+
				"</div>"+
				"<div class=\"gray-border mt_6\">"+
                "<input type=\"button\" class=\"green primary\" value=\"View Pending Payments\" id=\"view_pending_payments\">"+
				"</div>"+
                "<div class=\"display-none\">"+
                "<input type=\"text\" value=\"\" id=\"hide_error_accounts\">"+
                "</div>" 
            $("#footer_confirmation").append(footer_info).show();
            sendRequestToContainer(Messages.DISMISS_MASK_SUBMITTING,null);

        }
        if (info.direction == "out" )
        {
        	$("#confirmation_info_content").empty();
            $("#footer_confirmation").empty();
            $("#warn_confirmation").hide();
            // no click warn info
            if(is_click_billpay_error_page)
            {
            	showLoadingSpinners();
	            if(is_execute_view_pending_payments)
	            {
	            	is_execute_view_pending_payments = false;
	            	switchPages("PREVIEW_PENDING_PAYMENT", "DISABLE", $("#pending_total_pay").val(), "Pay Bills", "YES", "YES");
	            }
	            if(is_execute_pay_more_bills)
	            {
	            	is_execute_pay_more_bills = false;
	            	switchPages("PREVIEW_SCHEDULING_PAYMENT", "DISABLE", "0.00", "Pay Bills", "YES", "YES");
	            }
	            }
        }
    });

    $('#eligibility_error').bind('pageAnimationEnd', function (e, info)
    {
        if (info.direction == "out")
        {
            $('#eligibility_error_content').empty();
        }
    });

    $('#billpay_error').bind('pageAnimationStart', function (e, info)
    {
    	is_click_billpay_error_page = false;
        if (info.direction == "in")
        {
        	is_click_billpay_error_page = false;
        	if(init_billpay_error_loading){
        		init_billpay_error_loading= false;
                $("#billpay_error_ok").live("click", function ()
                {
                    if (confirmation == "pending")
                    {
                        is_closed = true;
                        pendingClickHandler();
                        is_submit_pending = false;
                        is_submit_schedule = false;
                        is_loading_pending = true;
                        is_loading_schedule = false;
                        $("#pending_see_history_info").show();
                        setLoadingMaskOnAvailableBalance();
                        $('#div_pending>ul').empty();
                        switchPages("PREVIEW_PENDING_PAYMENT", "DISABLE", $("#pending_total_pay").val(), "Pay Bills", "YES", "YES");
                        confirmation = "";
                    }
                    else
                    {
                        scheduleClickHandler();
                        is_submit_pending = false;
                        is_submit_schedule = false;
                        is_closed = true;
                        is_loading_pending = false;
                        is_loading_schedule = true;
                        $("#pending_see_history_info").hide();
                        setLoadingMaskOnAvailableBalance();
                        $('#div_schedule>ul').empty();
                        switchPages("PREVIEW_SCHEDULING_PAYMENT", "DISABLE", "0.00", "Pay Bills", "YES", "YES");
                        confirmation = "";
                    }
                    JQT.goBack("#home");
                });
            }
       }
    });
    $('#billpay_error').bind('pageAnimationEnd', function (e, info)
    {
        if (info.direction == "in")
        {
        	$('#billpay_error').css({'height':window.innerHeight});
            $("#billpay_error_account").text($("#hide_error_accounts").val());
        }
        if (info.direction == "out")
        {
        	showLoadingSpinners();
        }
        

    });

    $('#preview_changes').bind('pageAnimationEnd', function (e, info)
    {
        if (info.direction == "in")
        {
            $("#preview_changes").empty();
            var preview_payment_list_length = $("#div_pending>ul>li").length;
            var txt_accounts_list_value = formatAccount($("#hide_whole_selected_account").val());
            var temp_point = 1;
            for (var i = 1; i <= preview_payment_list_length; i++)
            {
                var name = $("#item_pending_payee_name" + i).text();
                var price = $("#item_pending_price" + i).text();
                var new_price = $("#item_pending_new_price" + i).text();
                var date_string = $.trim($("#item_pending_date" + i).text());
                var new_date_string = $.trim($("#item_pending_new_date" + i).text());
                var transaction_id = $("#item_pending_transaction_id" + i).text();
                var confirmation_number = $("#item_pending_confirmation_number" + i).text();
                var append_html_string = 
					"<article name=\"art_pending\">" +
					"<div class=\"title-bar\">" +
					"<div class=\"inner\">" +
					"<a>CHANGE "+temp_point+"</a>" +
					"</div>" +
					"</div>"+ 
					"<ul class=\"ul-pay\" name=\"ul_pending_preview\">" +
					"<li class=\"even-row\">" +
					"<div class=\"content-left\">Account</div>"+
					"<div class=\"content-right\" id=\"changes_account"+temp_point+"\">"+txt_accounts_list_value+"</div>" +
					"</li>" +
					"<li class=\"old-row\">" +
					"<div class=\"content-left\">Payee</div>" +
					"<div class=\"content-right\" id=\"changes_payee"+temp_point+"\">"+name+"</div>" +
					"</li>" +
					"<li class=\"even-row\">" +
					"<div class=\"content-left\">Amount</div>" +
					"<div class=\"content-right\" id=\"div_right_content\">";
				if(price == "CANCEL")
                {
					append_html_string+="" +
					"<a id=\"changes_amount"+temp_point+"\">CANCELLED</a>" +
					"</div>" +
					"</li>" +
					"<li class=\"old-row\">"+
					"<div class=\"content-left\">Deliver By</div>" +
					"<div class=\"content-right\" id=\"div_right_content\">"+
					"<a id=\"changes_deliverby"+temp_point+"\">CANCELLED</a>" +
					"</div>" +
					"<div class=\"display-none\">"+
					"<label id=\"preview_pending_transaction_id"+temp_point+"\">"+transaction_id+"</label>"+
					"<label id=\"preview_pending_confirmation_number"+temp_point+"\">"+confirmation_number+"</label>"+
					"</div>" +
					"</li>" +
					"</ul>" +
					"</article>";
					temp_point++;
				}
                else if(price != new_price || date_string != new_date_string)
                {
					var pricelabel = (price != new_price) ? "a":"span";
                    var datelable = (date_string != new_date_string) ? "a":"span";
                    append_html_string+=
                        "<"+pricelabel+" id=\"changes_amount"+temp_point+"\">$"+price+"</"+pricelabel+">" +
                        "</div>" +
                        "</li>" +
                        "<li class=\"old-row\">"+
                        "<div class=\"content-left\">Deliver By</div>" +
                        "<div class=\"content-right\" id=\"div_right_content\">"+
                        "<"+datelable+" class=\"text-decoration-none\" id=\"changes_deliverby"+temp_point+"\">"+date_string+"</"+datelable+">" +
                        "</div>" +
                        "<div class=\"display-none\">"+
                        "<label id=\"preview_pending_transaction_id"+temp_point+"\">"+transaction_id+"</label>"+
                        "<label id=\"preview_pending_confirmation_number"+temp_point+"\">"+confirmation_number+"</label>"+
                        "</div>" +
                        "</li>" +
                        "</ul>" +
                        "</article>";
                    temp_point++;
				}
                else
                {
					continue;
				}
                $("#preview_changes").append(append_html_string);
            }
            $('ul["name=ul_pending_preview"]:last').addClass('last-border');
            
            if (isPendingPaymentSingleChanged())
            {
            	 network_error_toolbar_text = "SUBMIT_CHANGE";
                switchPages("SUBMIT_CHANGE", "ENABLE", "", "Preview Changes", "YES");
            }
            else
            {
            	network_error_toolbar_text = "SUBMIT_CHANGES";
                switchPages("SUBMIT_CHANGES", "ENABLE", "", "Preview Changes", "YES");
            }
        }
        if (info.direction == "out")
        {
            $("#preview_changes").empty();
            is_double_click = false;
        }
    });

    $('#preview_payment').bind('pageAnimationEnd', function (e, info)
    {
        if (info.direction == "in")
        {
            // clean element contents
            $("#preview_payment_content").empty();
            $("#div_total").empty();
            $("#div_price").empty();
            var preview_payment_list_length = $("#div_schedule>ul>li").length;
            var txt_accounts_list_value = formatAccount($("#hide_whole_selected_account").val());
            var total_price = 0.0;
            var total_num = 0;
            for (var i = 1; i <= preview_payment_list_length; i++)
            {
                var schedule_value = $.trim($("#item_schedule" + i).text());
                if (schedule_value != "Schedule")
                {
                    schedule_value = schedule_value.substring(1);
                    var price = $("#item_schedule_price" + i).text();
                    var name = $("#item_schedule_payee_name" + i).text();
                    var date = $("#item_schedule_date" + i).text();
                    var payee_id = $("#item_schedule_payee_id" + i).text();
                    var ebill_id = $("#item_schedule_ebill_id" + i).text();
                    var append_html_string = "";
                    total_price = total_price + unFormatMoney(schedule_value);
                    total_num++;
                    append_html_string =
						"<article name=\"art_schedule_confirmation"+total_num+"\">" +
						"<div class=\"title-bar\">" +
						"<div class=\"inner\">" +
						"PAYMENT "+total_num+
						"</div>" +
						"</div>"+ 
						"<ul class=\"ul-pay\" name=\"ul_schedule\">" +
						"<li class=\"even-row\">" +
						"<div class=\"content-left\">Account</div>"+
						"<div class=\"content-right\" id=\"payment_account"+total_num+"\">"+txt_accounts_list_value+"</div>" +
						"</li>" +
						"<li class=\"old-row\"><div class=\"content-left\">Payee</div>" +
						"<div class=\"content-right\" id=\"payment_payee"+total_num+"\">"+name+"</div>" +
						"</li>" +
						"<li class=\"even-row\">" +
						"<div class=\"content-left\">Amount</div>" +
						"<div class=\"content-right\">"+
						"<span class=\"text-decoration-none font-weight-bold\" id=\"payment_amount"+total_num+"\">$"+schedule_value+"</span>" +
						"</div>" +
						"</li>" +
						"<li class=\"old-row\">"+
						"<div class=\"content-left\">Deliver By</div>" +
						"<div class=\"content-right\">"+
						"<span class=\"text-decoration-none\" id=\"payment_deliverby"+total_num+"\">"+date+"</span>" +
						"</div>" +
						"<div class=\"display-none\">"+
						"<label id=\"payment_payee_id"+total_num+"\">"+payee_id+"</label>"+
						"<label id=\"payment_ebill_id"+total_num+"\">"+ebill_id+"</label>"+
						"</div>" +
						"</li>" +
						"</ul>" +
						"</article>";

                    $("#preview_payment_content").append(append_html_string);
                }
            }
            $('ul["name=ul_schedule"]:last').addClass('last-border');
            $("#div_total").append("Total Payments (" + total_num + ")");
            $("#div_price").append("$" + formatNumber(total_price));
            
            if (isSchedulePaymentSingleChanged())
            {
            	network_error_toolbar_text = "SUBMIT_PAYMENT";
                switchPages("SUBMIT_PAYMENT", "", "", "Preview Payments", "YES");
            }
            else
            {
            	network_error_toolbar_text = "SUBMIT_PAYMENTS";
                switchPages("SUBMIT_PAYMENTS", "", "", "Preview Payments", "YES");
            }
            
        }
        if (info.direction == "out")
        {
            $("#preview_payment_content").empty();
            $("#div_total").empty();
            $("#div_price").empty();
            is_double_click = false;
        }
    });


    $('#update_pending').bind('pageAnimationStart', function (e, info)
    {
        if (info.direction == "in")
        {
        	if(init_update_pending_loading){
        		init_update_pending_loading = false;
        		
                $("#update_pending_payment").unbind("click");
                $("#update_pending_payment").bind("click", function ()
                {
                	is_back_from_auto_pay = false;
                    if ($('#update_pending_payment').attr('disabled') == false || $('#update_pending_payment').attr('disabled') == '')
                    {
                        $('#update_pending_payment').removeClass('green-hover');
                        is_back_to_pending_tab = true;
                        amount_on_update_button = getPayMoneyValue('pending');
                        // verify the account format.
                        var amount = $.trim(amount_on_update_button).toString().replace(/\,/g, '');

                        if ($.trim(amount).length <= 0)
                        { // as the amount equal blank.
                            showAlertBox("YES", "Amount Error", AMOUNT_EQUAL_BLANK_MSG, "OK");
                        }
                        else if (isNaN(amount))
                        { // as the amount is a non-numeric value
                            showAlertBox("YES", "Amount Error", AMOUNT_IS_A_NON_NUMERIC_MSG, "OK");
                        }
                        else if (amount <= 0)
                        { // as the amount equal zero or a negative value.
                            showAlertBox("YES", "Amount Error", AMOUNT_EQUAL_ZERO_OR_NEGATIVE_MSG, "OK");
                        }
                        else if (amount > MAX_CURRENCY)
                        { // as the amount is more than $99,999.99.
                            showAlertBox("YES", "Amount Error", AMOUNT_IS_EXCEEDING_MSG, "OK");
                        }
                        else if (compareFormatDate($('#item_pending_payee_earliest_date' + selected_pending_id).text(), getDeliverDateStringExceptWeekDay('pending')))
                        {
                            $('#warn_delivery_date').show();
                            $('#warn_delivery_date_message').text(SELECT_A_NEW_DELIVERY_DATE_MSG);
                        }
                        else
                        {
                            var decimal_fraction = amount.substring(amount.indexOf(".") + 1);
                            // as the amount include the decimal fraciton size
							// that is more than 2.
                            if (amount.indexOf(".") != -1 && decimal_fraction.length > 2)
                            {
                                showAlertBox("YES", "Amount Error", AMOUNT_DECIMAL_PLACES_EXCEEDS_TWO_MSG, "OK")
                            }
                            else
                            {
                                is_update_pending = true;
                                payment_deliver_date = getDeliverDateStringExceptWeekDay('pending');
                                $('#update_pending_payment').attr("disabled", "disabled").addClass("btn-disabled");
                                JQT.goBack("#home");
                                // count total pay
                                countTotalPayOfPendingPayment();
                                var is_toolbar_enable = "DISABLE";
                                if (isPendingPaymentChanged())
                                {
                                    is_toolbar_enable = "ENABLE";
                                }
                                // reset the toolbar .
                                switchPages("PREVIEW_PENDING_PAYMENT", is_toolbar_enable, $('#pending_total_pay').val(), "Pay Bills", "YES");
                              
                            }
                        }
                    }
                });

                $("#pending_warn").live("touchstart", function ()
                {
                    if (!is_double_click)
                    {
                        is_double_click = true;
                        goBackInfomations("", "", "", "Update Payment", "NO", "update_pending");
                        JQT.goTo('#warn_recurring_payment', 'slide'); // animation
                        switchPages("", "", "", "Important Information", "NO");
                    }
                });

                // cancel schedule payment
                $('#cancel_pending_payment').live("click", function ()
                {
                	is_back_from_auto_pay = false;
                    if ($('#cancel_pending_payment').attr('disabled') == '' || $('#cancel_pending_payment').attr('disabled') == false)
                    {
                        is_cancle_pending = true;
                        is_back_to_pending_tab = true;
                        var item_pending_price = $('#item_pending_price' + selected_pending_id).text();
                        if (item_pending_price != 'CANCEL')
                        {
                            $('#item_pending_last_price' + selected_pending_id).text($('#item_pending_price' + selected_pending_id).text());
                        }
                        $('#update_pending_payment').attr("disabled", "disabled").addClass("btn-disabled");
                        JQT.goBack("#home");
                        // count total pay
                        countTotalPayOfPendingPayment();
                        var is_toolbar_enable = "DISABLE";
                        if (isPendingPaymentChanged())
                        {
                            is_toolbar_enable = "ENABLE";
                        }
                        // reset the toolbar .
                        switchPages("PREVIEW_PENDING_PAYMENT", is_toolbar_enable, $('#pending_total_pay').val(), "Pay Bills", "YES");
                      
                    }
                });
            }
        	handlePendingWarnInfo();
        }
    });

    $('#update_pending').bind('pageAnimationEnd', function (e, info)
    {
        if (info.direction == "in" && !is_back_from_auto_pay )
        {
        	sendRequestToContainer(Messages.HIDE_LOADING,null);
            $('#warn_delivery_date').hide();
            is_item_line_double_click = true;
            // get value of special item by selected_schedule_id value
            var account_number = $('#item_pending_account_number' + selected_pending_id).text().replace("<span>", "").replace("</span>", "");
            var name = $('#item_pending_payee_name' + selected_pending_id).text();
            var price = $('#item_pending_price' + selected_pending_id).text();
            var date = $('#item_pending_date' + selected_pending_id).text();
            var due_date = $('#item_pending_new_date' + selected_pending_id).text();
            var due_price = $('#item_pending_new_price' + selected_pending_id).text();
            var account_status = $('#item_pending_status' + selected_pending_id).text();
            var last_price = $('#item_pending_last_price' + selected_pending_id).text();
            var weekday = "";
            if ($.trim(date).length != 0)
            {
                weekday = getWeekDay(date) + ",";
            }
            if ($.trim(account_status) != "Pending")
            {
                $('#txt_pending_pay_money_value').attr('readonly', 'readonly');
                $('#cancel_pending_payment').attr('disabled', 'disabled');
            }
            else
            {
                $('#txt_pending_pay_money_value').attr('readonly', '');
                $('#cancel_pending_payment').attr('disabled', '');
            }
            $("#pending_date").unbind("touchend");
            $("#pending_date").bind("touchend", function (e)
            {
                if ($.trim(account_status).toUpperCase() == "PENDING")
                {
                    addDateBoxShadow("pending");
                    // send date to object-c
                    var pending_payment_earlist_date = $('#item_pending_payee_earliest_date' + selected_pending_id).text();
                    payment_deliver_date = getDeliverDateStringExceptWeekDay('pending');
                    var due_date = $('#item_pending_new_date' + selected_pending_id).text();
                    var is_warn_info = isWarningMessageVisible('PENDING') ? 'YES' : 'NO';
                    setTimeout(function()
                    {
                    	if(pending_payment_earlist_date != null && $.trim(pending_payment_earlist_date).length != 0)
                        {
                            sendDeliverDateOfSchedulePayment($.trim(payment_deliver_date), '', is_warn_info, $.trim(pending_payment_earlist_date));
                        }
                        else
                        {
                            sendDeliverDateOfSchedulePayment($.trim(payment_deliver_date), '', is_warn_info, $.trim(due_date));
                        }
                    },10);

                }
            });

            $('#txt_pending_pay_money_value').live('keyup', function ()
            {
                if ($.trim(account_status) == "Pending" && !isUpdateButtonDisabled("pending"))
                {
                    $('#update_pending_payment').attr("disabled", "").removeClass("btn-disabled");
                }
                else
                {
                    $('#update_pending_payment').attr("disabled", "disabled").addClass("btn-disabled");
                }
            });

            $('#txt_pending_pay_money_value').live('click', function ()
            {
            	sendRequestToContainer(Messages.POPUP_NUMBER_KEYBOARD,null);
             });
            $('#txt_pending_pay_money_value').live('mouseup', function ()
            {
                if ($.trim(account_status) == "Pending" && !isUpdateButtonDisabled("pending"))
                {
                    $('#update_pending_payment').attr("disabled", "").removeClass("btn-disabled");
                }
                else
                {
                    $('#update_pending_payment').attr("disabled", "disabled").addClass("btn-disabled");
                }
            });

            $('#pending_lbl_title').text(name);
            $("<label id=\"pending_lbl_title_label\" class=\"font-weight-normal\">&nbsp;Payment</label>").insertAfter("#pending_lbl_title");

            if (account_number != 'undefined' && $.trim(account_number).length != 0)
            {
            	$('#pending_lbl_accountNo').text(getMaskedAccountNumberWithParenthesis(account_number)).show();
            }
            else
            {
                $('#pending_lbl_accountNo').hide();
            }
            if (price == "CANCEL")
            {
                price = last_price;
                $('#update_pending_payment').attr("disabled", "").removeClass("btn-disabled");
            }
            if ($.trim(price) != $.trim(due_price) || $.trim(date) != $.trim(due_date))
            {
                $('#lbl_pending_payment').text(price);
                $('#pending_time').text(date);
                $('#pending_pay_info').show();
            }
            else
            {
                $('#pending_pay_info').hide();
            }
            if ($('#update_pending_payment').attr("disabled") != true && $('#item_pending_price' + selected_pending_id).text() != "CANCEL")
            {
                var temp_hide_date = $('#pending_hide_retain_deliver_date').val();
                $('#txt_pending_pay_money_value').val($('#pending_hide_retain_amount').val());
                $('#txt_pending_deliver_date').val(temp_hide_date);
            }
            else
            {
                $("#txt_pending_pay_money_value").attr('placeholder', price);
                // set deliver date
                $("#txt_pending_deliver_date").val(' ' + weekday + date);
            }
            
            switchPages("", "DISABLE", "", "Update Payment", "NO");
        }
        if(info.direction == "out")
        {
            $('#pending_lbl_accountNo').empty();
            $('#pending_lbl_title').empty();
            $('#pending_lbl_title_label').remove();
        }
    });


    $('#update_schedule').bind('pageAnimationStart', function (e, info)
    {
        if (info.direction == "in")
        {
        	if(init_update_schedule_loading){
        		init_update_schedule_loading = false;

                // update payments button event
                $("#update_schedule_payment,#schedule_schedule_payment").unbind("click");
                $("#update_schedule_payment,#schedule_schedule_payment").bind("click", function ()
                {
                    if ($('#update_schedule_payment,#schedule_schedule_payment').attr('disabled') == '')
                    {
                        is_back_to_schedule_tab = true;
                        amount_on_update_button = getPayMoneyValue('schedule');
                        var amount = $.trim(amount_on_update_button).toString().replace(/\,/g, '');
                        var temp_schedule_date = getDeliverDateStringExceptWeekDay('schedule');
                        if ($.trim(amount).length <= 0)
                        { // as the amount equal blank.
                            showAlertBox("YES", "Amount Error", AMOUNT_EQUAL_BLANK_MSG, "OK");
                        }
                        else if (isNaN(amount))
                        { // as the amount is a non-numeric value
                            showAlertBox("YES", "Amount Error", AMOUNT_IS_A_NON_NUMERIC_MSG, "OK");
                        }
                        else if (amount <= 0)
                        { // as the amount equal zero or a negative value.
                            showAlertBox("YES", "Amount Error", AMOUNT_EQUAL_ZERO_OR_NEGATIVE_MSG, "OK");
                        }
                        else if (amount > MAX_CURRENCY)
                        { // as the amount is more than $99,999.99.
                            showAlertBox("YES", "Amount Error", AMOUNT_IS_EXCEEDING_MSG, "OK");
                        }
                        else if (compareFormatDate($('#item_earliest_payment_date' + selected_schedule_id).text(), temp_schedule_date))
                        {
                            $('#schedule_warn_delivery_date').show();
                            $('#schedule_warn_delivery_date_message').text(SELECT_A_NEW_DELIVERY_DATE_MSG);
                        }
                        else
                        {
                            var decimal_fraction = amount.substring(amount.indexOf(".") + 1);
                            // as the amount include the decimal fraciton size
							// that is more than 2.
                            if (amount.indexOf(".") != -1 && decimal_fraction.length > 2)
                            {
                                showAlertBox("YES", "Amount Error", AMOUNT_DECIMAL_PLACES_EXCEEDS_TWO_MSG, "OK")
                            }
                            else
                            {
                                payment_deliver_date = ' ' + temp_schedule_date;
                                // give the hidden area set status
                                $("#status_preview_button").val("YES");
                                is_update_schedule = true;
                                $('#update_schedule_payment,#schedule_schedule_payment').attr("disabled", "disabled").addClass("btn-disabled");
                                // send money to object-c
                                JQT.goBack("#home");
                             // count total pay
                                countTotalPayOfSchedulePayment();
                                var is_toolbar_enable = "DISABLE";
                                $("#div_schedule .table-row").each(function (i)
                                {
                                    if ($('#item_schedule' + (i + 1)).text() != "Schedule")
                                    {
                                        is_toolbar_enable = "ENABLE";
                                    }

                                });
                                switchPages("PREVIEW_SCHEDULING_PAYMENT", is_toolbar_enable, $("#schedule_total_pay").val(), "Pay Bills", "YES");
                            }
                        }
                    }
                });

                $("#schedule_warn").live("touchstart", function ()
                {
                    if (!is_double_click)
                    {
                        is_double_click = true;
                        goBackInfomations("", "", "", $('#schedule_title').val(), "NO", "update_schedule");
                        JQT.goTo('#warn_recurring_payment', 'slide'); // animation
                        switchPages("", "", "", "Important Information", "NO");
                    }
                });

                // cancel schedule payment
                $('#cancel_schedule_payment').live("click", function ()
                {
                    is_cancle_schedule = true;
                    is_back_to_schedule_tab = true;
                    $('#update_schedule_payment,#schedule_schedule_payment').attr("disabled", "disabled").addClass("btn-disabled");
                    JQT.goBack("#home");
                 // count total pay
                    countTotalPayOfSchedulePayment();
                    var is_toolbar_enable = "DISABLE";
                    $("#div_schedule .table-row").each(function (i)
                    {
                        if ($('#item_schedule' + (i + 1)).text() != "Schedule")
                        {
                            is_toolbar_enable = "ENABLE";
                        }

                    });
                    switchPages("PREVIEW_SCHEDULING_PAYMENT", is_toolbar_enable, $("#schedule_total_pay").val(), "Pay Bills", "YES");
                });

           }
            handleSchedualWarnInfo();
        }
    });

    $('#update_schedule').bind('pageAnimationEnd', function (e, info)
    {
        if (info.direction == "in")
        {
        	sendRequestToContainer(Messages.HIDE_LOADING,null);
            var ebill_conents = $("#is_show" + selected_schedule_id).text();
            // get value of special item by selected_schedule_id value
            var last_payment_amount = $('#last_payment_amount' + selected_schedule_id).text();
            var last_payment_due_date = $('#last_payment_due_date' + selected_schedule_id).text();
            var last_payment_bill_status = $('#last_payment_bill_status' + selected_schedule_id).text();
            var item_earliest_payment_date = $('#item_earliest_payment_date' + selected_schedule_id).text();
            var account_number = $('#item_schedule_account_number' + selected_schedule_id).text();
            var ebill_due_date = $('#ebill_due_date' + selected_schedule_id).text();
            var ebill_amount_due = $('#ebill_amount_due' + selected_schedule_id).text();
            var name = $('#item_schedule_payee_name' + selected_schedule_id).text();
            var price = $('#item_schedule_price' + selected_schedule_id).text();
            var date = $('#item_schedule_date' + selected_schedule_id).text();
            var item_schedule = $('#item_schedule' + selected_schedule_id).text();

            $('#schedule_warn_delivery_date').hide();
            is_item_line_double_click = true;
            $("#schedule_date").unbind("touchend");
            $("#schedule_date").bind("touchend", function (e)
            {
                addDateBoxShadow("schedule");
                // send date to object-c
                payment_deliver_date = getDeliverDateStringExceptWeekDay('schedule');
                var due_date = $('#item_schedule_date' + selected_schedule_id).text();
                var is_warn_info = isWarningMessageVisible('SCHEDULE') ? 'YES' : 'NO';
                setTimeout(function()
                {
                    if ($('#is_show' + selected_schedule_id).text() == 'true' && $.trim($('#lbl_schedule_deliver_date_value').text()).length != 0)
                    {
                        sendDeliverDateOfSchedulePayment($.trim(payment_deliver_date), $.trim(due_date), is_warn_info, item_earliest_payment_date);
                    }
                    else
                    {
                        sendDeliverDateOfSchedulePayment($.trim(payment_deliver_date), '', is_warn_info, item_earliest_payment_date);
                    }
                },10);

            });
            
            // change button (schedule) style and whether to display the inital
			// date
            var style_of_schedule_button = $('#item_schedule' + selected_schedule_id).attr("class");
            if (style_of_schedule_button.indexOf("added") != -1)
            { // attr includes css added and sub
                $('#cancel_payment').removeClass().addClass("show-schedule-cancel-button ml4");
                $('#schedule_title').val("Update Payment");
                $('#btn_schedule_schedule_payment').removeClass().addClass("display-none gray-border sub-btn-bottom ml4");
            }
            else
            {
                $('#cancel_payment').removeClass().addClass("display-none ml4");
                $('#schedule_title').val("Schedule Payment");
                $('#btn_schedule_schedule_payment').removeClass().addClass("show-schedule-cancel-button gray-border sub-btn-bottom ml4");
            }

            // name
            $("#schedule_lbl_title").empty().text(name);
            $("<label id=\"schedule_lbl_title_label\" class=\"font-weight-normal\">&nbsp;Payment</label>").insertAfter("#schedule_lbl_title");
            if (account_number != 'undefined' && $.trim(account_number).length != 0)
            {
            	$('#schedule_lbl_accountNo').show().text(getMaskedAccountNumberWithParenthesis(account_number));
            }
            else
            {
                $('#schedule_lbl_accountNo').hide();
            }
            
            var weekday = "";
            if ($.trim(date).length != 0)
            {
                weekday = getWeekDay(date) + ", ";
            }
         
            if ($.trim(ebill_conents) != "true")
            {
                $("#schedule_pay_info").empty().hide();
                // pay money of text tag
                if (item_schedule.toUpperCase() == "SCHEDULE")
                {
                    $("#txt_schedule_pay_money_value").attr("placeholder", "0.00");
                }
                else
                {
                    $("#txt_schedule_pay_money_value").attr("placeholder", item_schedule.substring(1));
                }
                
                if ($.trim(price) != 0 && $.trim(date) != 0)
                {
                    var header_info = "$<label id=\"lbl_shcedule_payment\">" + price + "</label>&nbsp;Deliver by<time id=\"schedule_time\">" + date + "</time>";
                    $("#schedule_pay_info").empty().append(header_info).show();
                }
                // pay money of label tag
                $("#lbl_schedule_money_value").text('');
                // devliver date of label tag
                $("#lbl_schedule_deliver_date_value").text('');
            }
            else
            {
                $("#schedule_pay_info").empty().hide();
                if (item_schedule.toUpperCase() == "SCHEDULE")
                {
                    if (last_payment_bill_status.toUpperCase() == "UNPAID" || last_payment_bill_status.toUpperCase() == "PROCESSED")
                    {
                        var header_info = "";
                        if (last_payment_bill_status.toUpperCase() == "UNPAID")
                        {
                            header_info = "$<label id=\"lbl_shcedule_payment\">" + ebill_amount_due + "</label>&nbsp;due&nbsp;<time id=\"schedule_time\">" + ebill_due_date + "</time>";
                         
                        }
                       if (last_payment_amount !== undefined && last_payment_amount != "") 
                        {
                            header_info += "<div>Last Payment:&nbsp;$<label id=\"lbl_shcedule_payment\">" + last_payment_amount + "</label>&nbsp;on&nbsp;<time id=\"schedule_time\">" + last_payment_due_date + "</time></div>";
                        }
                        //date
                        $("#schedule_time").text(last_payment_due_date);
                        //last payment price
                        $("#lbl_shcedule_payment").text(ebill_amount_due);
                        $("#schedule_pay_info").append(header_info).show();
                    }
                }
                else
                {
                	 var header_info = "$<label id=\"lbl_shcedule_payment\">" + price + "</label>&nbsp;Deliver by<time id=\"schedule_time\">" + date + "</time>";
                     if (last_payment_amount !== undefined && last_payment_amount != "") 
                     {
                         header_info += "<div>Last Payment:&nbsp;$<label id=\"lbl_shcedule_payment\">" + last_payment_amount + "</label>&nbsp;on&nbsp;<time id=\"schedule_time\">" + last_payment_due_date + "</time></div>";
                     }
                     $("#schedule_pay_info").append(header_info).show();
                }

                if (last_payment_bill_status.toUpperCase() != "PROCESSED")
                {
                    // pay money of label tag
                    $("#lbl_schedule_money_value").text("($" + $.trim(ebill_amount_due) + " owed)");
                    // devliver date of label tag
                    $("#lbl_schedule_deliver_date_value").text("(due " + $.trim(ebill_due_date) + ")");
                }
                else
                {
                    // pay money of label tag
                    $("#lbl_schedule_money_value").text('');
                    // devliver date of label tag
                    $("#lbl_schedule_deliver_date_value").text('');
                }
            }

            if ($('#update_schedule_payment,#schedule_schedule_payment').attr("disabled") == "disabled" || $('#update_schedule_payment,#schedule_schedule_payment').attr("disabled") == false)
            {
                var temp_hide_date = $('#schedule_hide_retain_deliver_date').val();
                $('#txt_schedule_pay_money_value').val($('#schedule_hide_retain_amount').val());
                $('#txt_schedule_deliver_date').val(temp_hide_date);
            }
            else
            {
                if (item_schedule != "Schedule")
                {
                    $("#txt_schedule_pay_money_value").attr("placeholder", item_schedule.substring(1));
                }
                else
                {
                    $("#txt_schedule_pay_money_value").attr("placeholder", "0.00");
                }
                // set deliver date
                if (date === undefined || date == null || date.length <= 0 || (last_payment_bill_status.toUpperCase() == "PROCESSED" && item_schedule.toUpperCase() == "SCHEDULE"))
                {
                    $("#txt_schedule_deliver_date").val(' ' + getWeekDay(item_earliest_payment_date) + ", " + item_earliest_payment_date);
                }
                else
                {
                    $("#txt_schedule_deliver_date").val(' ' + weekday + $.trim(date));
                }
            }
            $('#txt_schedule_pay_money_value').live('keyup', function ()
            {
            	
                if (!isUpdateButtonDisabled("schedule"))
                {
                    $('#update_schedule_payment,#schedule_schedule_payment').attr("disabled", "").removeClass("btn-disabled");
                }
                else
                {
                    $('#update_schedule_payment,#schedule_schedule_payment').attr("disabled", "disabled").addClass("btn-disabled");
                }
            	
            });

            $('#txt_schedule_pay_money_value').live('mouseup', function ()
            {
                if (!isUpdateButtonDisabled("schedule"))
                {
                    $('#update_schedule_payment,#schedule_schedule_payment').attr("disabled", "").removeClass("btn-disabled");
                }
                else
                {
                    $('#update_schedule_payment,#schedule_schedule_payment').attr("disabled", "disabled").addClass("btn-disabled");
                }
                
            });
            $('#txt_schedule_pay_money_value').live('click', function ()
            {
            	sendRequestToContainer(Messages.POPUP_NUMBER_KEYBOARD,null);
             });
            
            if ($("#item_schedule" + selected_schedule_id).text() == "Schedule")
            {
                switchPages("", "DISABLE", "", "Schedule Payment", "NO");
            }
            else
            {
                switchPages("", "ENABLE", "", "Update Payment", "NO");
            }
            
        }
        if (info.direction == "out")
        {
        	$("#schedule_pay_info").empty();
            $("#schedule_lbl_title").empty();
            $('#schedule_lbl_accountNo').empty();
            $('#schedule_lbl_title_label').remove();
            $('#cancel_payment').removeClass().addClass("display-none ml4");
            $('#btn_schedule_schedule_payment').removeClass().addClass("display-none gray-border sub-btn-bottom ml4");
        }
    });

    $('#warn_recurring_payment').bind('pageAnimationEnd', function (e, info)
    {
        if (info.direction == "in")
        {
        	is_back_from_auto_pay = true;
        	$('#warn_recurring_payment').css({'height':window.innerHeight});
            $('#warn_messages').text("");
            if ($.trim(selected_pending_id).length != 0)
            {
                if ($('#update_pending_payment').attr("disabled") != "disable" || $('#update_pending_payment').attr("disabled"))
                {
                    var retain_deliver_date = $('#txt_pending_deliver_date').val();
                    $('#pending_hide_retain_amount').val($('#txt_pending_pay_money_value').val());
                    if ($.trim(retain_deliver_date).length != 0)
                    {
                        $('#pending_hide_retain_deliver_date').val(retain_deliver_date);
                    }
                }
                else
                {
                    $('#pending_hide_retain_amount').val("");
                    $('#pending_hide_retain_deliver_date').val("");
                }
                $('#warn_messages').text($('#pending_hide_warn_messages').val());
            }
            else
            {
                if ($('#update_pending_payment').attr("disabled") != "disable" || $('#update_pending_payment').attr("disabled"))
                {
                    var temp_date = $('#txt_schedule_deliver_date').val();
                    $('#schedule_hide_retain_amount').val($('#txt_schedule_pay_money_value').val());
                    $('#schedule_hide_retain_deliver_date').val(temp_date);
                }
                else
                {
                    $('#schedule_hide_retain_amount').val("");
                    $('#schedule_hide_retain_deliver_date').val("");
                }
                $('#warn_messages').text($('#schedule_hide_warn_messages').val());
            }
        }
        if (info.direction == "out")
        {
            is_double_click = false;
        }
    });
});